
;CodeVisionAVR C Compiler V1.25.5 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16L
;Program type           : Application
;Clock frequency        : 7.372800 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16L
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "wiznet.vec"
	.INCLUDE "wiznet.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.5 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 12/26/2007
;      11 Author  : engahmad
;      12 Company : BAU
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16L
;      17 Program type        : Application
;      18 Clock frequency     : 7.372800 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <delay.h>
;      37 #include <stdio.h>
;      38 #include<Lcd.h>
;      39 #include <ds1302.h>
;      40 #asm
;      41    .equ __lcd_port=0x1B;PORTA
   .equ __lcd_port=0x1B;PORTA
;      42 #endasm
;      43 #asm
;      44    .equ __ds1302_port=0x12 ;PORTD
   .equ __ds1302_port=0x12 ;PORTD
;      45    .equ __ds1302_io=6
   .equ __ds1302_io=6
;      46    .equ __ds1302_sclk=5
   .equ __ds1302_sclk=5
;      47    .equ __ds1302_rst=7
   .equ __ds1302_rst=7
;      48 #endasm
;      49 
;      50 #define CHECKBIT(ADDRESS,BIT) (ADDRESS & (1<<BIT))
;      51 
;      52 // Declare your global variables here
;      53 
;      54 #define Alarm  PIND.2
;      55 #define light PORTD.4
;      56 
;      57 // Define SPI-related pins
;      58 
;      59 #define SCK  7 // (Serial Clock)
;      60 #define MISO  6 //(Master In / Slave Out)
;      61 #define MOSI 5 // (Master Out / Slave In)
;      62 #define SLAVE_SELECT 4 // SS (Slave Select)
;      63 
;      64 // SPSR
;      65 #define SPIF 7
;      66 
;      67 // SPCR
;      68 #define SPE 6
;      69 #define MSTR 4
;      70 #define CPHA 2
;      71 #define SPR0 0
;      72 
;      73 
;      74 #define PIN_RESET 0 // WIZnet module /RESET
;      75 
;      76 #define WIZNET_OPCODE_READ 0x0F
;      77 #define WIZNET_OPCODE_WRITE 0xF0
;      78 
;      79 #define DUMMY_DATA 0xFF
;      80 
;      81 #define make8(var,offset)	((unsigned int)var >> (offset * 8)) & 0x00FF
;      82 #define	make16(varhigh,varlow)	(((unsigned int)varhigh & 0xFF)* 0x100) + ((unsigned int)varlow & 0x00FF)
;      83 #define make32(var1,var2,var3,var4) \((unsigned long)var1<<24)+((unsigned long)var2<<16)+ \((unsigned long)var3<<8)+((unsigned long)var4)
;      84 
;      85 #define chip_base_address 		0x0000
;      86 #define RX_memory_base_address	0x6000
;      87 #define gS0_RX_BASE 			chip_base_address + RX_memory_base_address
;      88 #define gS0_RX_MASK				0x0800 - 1
;      89 #define gS1_RX_BASE				gS0_RX_BASE + (gS0_RX_MASK + 1)
;      90 #define gS1_RX_MASK				0x0800 - 1
;      91 #define gS2_RX_BASE				gS1_RX_BASE + (gS1_RX_MASK + 1)
;      92 #define gS2_RX_MASK				0x0800 - 1
;      93 #define gS3_RX_BASE				gS2_RX_BASE + (gS2_RX_MASK + 1)
;      94 #define gS3_RX_MASK				0x0800 - 1
;      95 #define TX_memory_base_address	0x4000
;      96 #define gS0_TX_BASE 			chip_base_address + TX_memory_base_address
;      97 #define gS0_TX_MASK				0x0800 - 1
;      98 #define gS1_TX_BASE				gS0_TX_BASE + (gS0_TX_MASK + 1)
;      99 #define gS1_TX_MASK				0x0800 - 1
;     100 #define gS2_TX_BASE				gS1_TX_BASE + (gS1_TX_MASK + 1)
;     101 #define gS2_TX_MASK				0x0800 - 1
;     102 #define gS3_TX_BASE				gS2_TX_BASE + (gS2_TX_MASK + 1)
;     103 #define gS3_TX_MASK				0x0800 - 1
;     104 
;     105 //******************************************************************
;     106 //*	Receive Ring Buffer Header Layout
;     107 //*   This is the 4-byte header that resides infront of the
;     108 //*   data packet in the receive buffer.
;     109 //******************************************************************
;     110 unsigned char  packetheader[6];
_packetheader:
	.BYTE 0x6
;     111 //******************************************************************
;     112 //*	Ethernet Header Layout
;     113 //******************************************************************
;     114 volatile unsigned char  packet[500];
_packet:
	.BYTE 0x1F4
;     115 //******************************************************************
;     116 //*	IP Header Layout
;     117 //******************************************************************
;     118 #define	ip_srcaddr		   0x1A	//IP address of source
;     119 #define	ip_destaddr		   0x1E	//IP addess of destination
;     120 #define	ip_data			   0x22	//IP data area
;     121 //******************************************************************
;     122 //*	TCP Header Layout
;     123 //******************************************************************
;     124 #define	TCP_srcport		   0x22	//TCP source port
;     125 #define	TCP_destport   	   0x24	//TCP destination port
;     126 #define	TCP_seqnum  	   0x26	//sequence number
;     127 #define	TCP_acknum	       0x2A	//acknowledgement number
;     128 #define	TCP_hdrflags	   0x2E	//4-bit header len and flags
;     129 #define	TCP_window		   0x30	//window size
;     130 #define	TCP_cksum		   0x32	//TCP checksum
;     131 #define	TCP_urgentptr      0x34	//urgent pointer
;     132 #define TCP_data           0x36 //option/data
;     133 //******************************************************************
;     134 //*	IP Protocol Types
;     135 //******************************************************************
;     136 #define	PROT_ICMP			   0x01
;     137 #define	PROT_TCP			   0x06
;     138 #define	PROT_UDP			   0x11
;     139 //******************************************************************
;     140 //*	ICMP Header
;     141 //******************************************************************
;     142 #define	ICMP_type			   ip_data
;     143 #define	ICMP_code			   ICMP_type+1
;     144 #define	ICMP_cksum			   ICMP_code+1
;     145 #define	ICMP_id				   ICMP_cksum+2
;     146 #define	ICMP_seqnum			   ICMP_id+2
;     147 #define ICMP_data              ICMP_seqnum+2
;     148 //******************************************************************
;     149 //*	UDP Header
;     150 //******************************************************************
;     151 #define	UDP_srcport			   ip_data
;     152 //#define	UDP_destport		   UDP_srcport+2
;     153 //#define	UDP_len				   UDP_destport+2
;     154 //#define	UDP_cksum			   UDP_len+2
;     155 #define	UDP_data			   UDP_srcport+2
;     156 //******************************************************************
;     157 //*	DHCP Message
;     158 //******************************************************************
;     159 #define	DHCP_op					UDP_data
;     160 #define	DHCP_htype				DHCP_op+1
;     161 #define DHCP_hlen				DHCP_htype+1
;     162 #define DHCP_hops				DHCP_hlen+1
;     163 #define DHCP_xid				DHCP_hops+1
;     164 #define DHCP_secs				DHCP_xid+4
;     165 #define DHCP_flags				DHCP_secs+2
;     166 #define DHCP_ciaddr				DHCP_flags+2
;     167 #define DHCP_yiaddr				DHCP_ciaddr+4
;     168 #define DHCP_siaddr				DHCP_yiaddr+4
;     169 #define DHCP_giaddr				DHCP_siaddr+4
;     170 #define DHCP_chaddr				DHCP_giaddr+4
;     171 #define DHCP_sname				DHCP_chaddr+16
;     172 #define DHCP_file				DHCP_sname+64
;     173 #define DHCP_options			DHCP_file+128
;     174 #define DHCP_message_end		DHCP_options+312
;     175 
;     176 #define COMMON_BASE	0x0000
;     177 
;     178 #define GAR0			0x01
;     179 #define SUBR0			0x05
;     180 #define SHAR0			0x09
;     181 #define SIPR0			0x0F
;     182 #define IR				0x15
;     183 #define IMR			  0x16
;     184 #define RTR0			0x17
;     185 
;     186 //  Sn_MR values
;     187 #define Sn_MR_CLOSE		0x00		// unused socket
;     188 #define Sn_MR_TCP		0x01		// TCP
;     189 #define Sn_MR_UDP		0x02		// UDP
;     190 #define Sn_MR_IPRAW	0x03		// IP LAYER RAW SOCK
;     191 #define Sn_MR_MACRAW	0x04		// MAC LAYER RAW SOCK
;     192 #define Sn_MR_PPPOE		0x05		// PPPoE
;     193 #define Sn_MR_ND		0x20		// No Delayed Ack(TCP) flag
;     194 #define Sn_MR_MULTI		0x80		// support multicating
;     195 
;     196 //  Sn_CR values
;     197 #define Sn_CR_OPEN		0x01		// initialize or open socket
;     198 #define Sn_CR_LISTEN		0x02		// wait connection request in tcp mode(Server mode)
;     199 #define Sn_CR_CONNECT	0x04		// send connection request in tcp mode(Client mode)
;     200 #define Sn_CR_DISCON		0x08		// send closing reqeuset in tcp mode
;     201 #define Sn_CR_CLOSE		0x10		// close socket
;     202 #define Sn_CR_SEND		0x20		// updata txbuf pointer, send data
;     203 #define Sn_CR_SEND_MAC	0x21		// send data with MAC address, so without ARP process
;     204 #define Sn_CR_SEND_KEEP	0x22		//  send keep alive message
;     205 #define Sn_CR_RECV		0x40		// update rxbuf pointer, recv data
;     206 
;     207 
;     208 //  Sn_SR values
;     209 #define SOCK_CLOSED				0x00		// closed
;     210 #define SOCK_INIT 				0x13		// init state
;     211 #define SOCK_LISTEN				0x14		// listen state
;     212 #define SOCK_SYNSENT	   		0x15		// connection state
;     213 #define SOCK_SYNRECV		   	0x16		// connection state
;     214 #define SOCK_ESTABLISHED		0x17		// success to connect
;     215 #define SOCK_FIN_WAIT			0x18		// closing state
;     216 #define SOCK_CLOSING		   	0x1A		// closing state
;     217 #define SOCK_TIME_WAIT			0x1B		// closing state
;     218 #define SOCK_CLOSE_WAIT			0x1C		// closing state
;     219 #define SOCK_LAST_ACK			0x1D		// closing state
;     220 #define SOCK_UDP				   0x22		// udp socket
;     221 #define SOCK_IPRAW			   0x32		// ip raw mode socket
;     222 #define SOCK_MACRAW			   0x42		// mac raw mode socket
;     223 #define SOCK_PPPOE				0x5F		// pppoe socket
;     224 
;     225 
;     226 //*
;     227 //* socket register
;     228 //*
;     229 #define CH_BASE (COMMON_BASE + 0x0400)
;     230 //*
;     231 //*	size of each channel register map
;     232 //*
;     233 #define CH_SIZE		0x0100
;     234 //*
;     235 //* socket Mode register
;     236 //*
;     237 #define Sn_MR(ch)		(CH_BASE + ch * CH_SIZE + 0x0000)
;     238 //*
;     239 //* channel Sn_CR register
;     240 //*
;     241 #define Sn_CR(ch)				(CH_BASE + ch * CH_SIZE + 0x0001)
;     242 //*
;     243 //* channel interrupt register
;     244 //*
;     245 #define Sn_IR(ch)			(CH_BASE + ch * CH_SIZE + 0x0002)
;     246 //*
;     247 //* channel status register
;     248 //*
;     249 #define Sn_SR(ch)			(CH_BASE + ch * CH_SIZE + 0x0003)
;     250 //*
;     251 //* source port register
;     252 //*
;     253 #define Sn_PORT0(ch)		(CH_BASE + ch * CH_SIZE + 0x0004)
;     254 #define Sn_PORT1(ch)		(CH_BASE + ch * CH_SIZE + 0x0005)
;     255 //*
;     256 //* Peer MAC register address
;     257 //*
;     258 #define Sn_DHAR0(ch)			(CH_BASE + ch * CH_SIZE + 0x0006)
;     259 //*
;     260 //* Peer IP register address
;     261 //*
;     262 #define Sn_DIPR0(ch)			(CH_BASE + ch * CH_SIZE + 0x000C)
;     263 //*
;     264 //* Peer port register address
;     265 //*
;     266 #define Sn_DPORT0(ch)		(CH_BASE + ch * CH_SIZE + 0x0010)
;     267 //*
;     268 //* Maximum Segment Size(Sn_MSSR0) register address
;     269 //*
;     270 #define Sn_MSSR0(ch)					(CH_BASE + ch * CH_SIZE + 0x0012)
;     271 //*
;     272 //* Protocol of IP Header field register in IP raw mode
;     273 //*
;     274 #define Sn_PROTO(ch)			(CH_BASE + ch * CH_SIZE + 0x0014)
;     275 
;     276 //*
;     277 //* IP Type of Service(TOS) Register
;     278 //*
;     279 #define Sn_TOS(ch)						(CH_BASE + ch * CH_SIZE + 0x0015)
;     280 //*
;     281 //* IP Time to live(TTL) Register
;     282 //*
;     283 #define Sn_TTL(ch)						(CH_BASE + ch * CH_SIZE + 0x0016)
;     284 
;     285 
;     286 
;     287 //*
;     288 //* Transmit free memory size register
;     289 //*
;     290 #define Sn_TX_FSR0(ch)	(CH_BASE + ch * CH_SIZE + 0x0020)
;     291 #define Sn_TX_FSR1(ch)	(CH_BASE + ch * CH_SIZE + 0x0021)
;     292 //* Transmit memory read pointer register address
;     293 //*
;     294 #define Sn_TX_RD0(ch)			(CH_BASE + ch * CH_SIZE + 0x0022)
;     295 #define Sn_TX_RD1(ch)			(CH_BASE + ch * CH_SIZE + 0x0023)
;     296 //* Transmit memory write pointer register address
;     297 //*
;     298 #define Sn_TX_WR0(ch)			(CH_BASE + ch * CH_SIZE + 0x0024)
;     299 #define Sn_TX_WR1(ch)			(CH_BASE + ch * CH_SIZE + 0x0025)
;     300 //* Received data size register
;     301 //*
;     302 #define Sn_RX_RSR0(ch)	(CH_BASE + ch * CH_SIZE + 0x0026)
;     303 #define Sn_RX_RSR1(ch)	(CH_BASE + ch * CH_SIZE + 0x0027)
;     304 //*
;     305 //* Read point of Receive memory
;     306 //*
;     307 #define Sn_RX_RD0(ch)			(CH_BASE + ch * CH_SIZE + 0x0028)
;     308 #define Sn_RX_RD1(ch)			(CH_BASE + ch * CH_SIZE + 0x0029)
;     309 //*
;     310 //* Write point of Receive memory
;     311 //*
;     312 #define Sn_RX_WR0(ch)			(CH_BASE + ch * CH_SIZE + 0x002A)
;     313 
;     314 
;     315 
;     316 /*****************************************************
;     317 Socket Types
;     318 *****************************************************/
;     319 typedef enum
;     320 {
;     321 UDP=0x01,
;     322 TCP=0x02
;     323 }protocol;
;     324 /*****************************************************
;     325 Socket Number
;     326 *****************************************************/
;     327 typedef enum
;     328 {
;     329 Sock0=0x00,
;     330 Sock1=0x01,
;     331 Sock2=0x02,
;     332 Sock3=0x03
;     333 }sock;
;     334 
;     335 
;     336 unsigned int  source_port_number;
;     337 
;     338 /*****************************************************
;     339 Read and Write Functions
;     340 *****************************************************/
;     341 
;     342 void initialize();
;     343 unsigned char wiz_rd(unsigned int address) ;
;     344 void wiz_wr(unsigned int address, unsigned int targetValue);
;     345 
;     346 unsigned char spi_transfer(volatile unsigned char data);
;     347 
;     348 /*****************************************************
;     349 Set Source Ip functions
;     350 *****************************************************/
;     351 void setGAR (unsigned char * addr);
;     352 void setSUBR(unsigned char * addr);
;     353 void setSHAR(unsigned char * addr);
;     354 void setSIPR(unsigned char * addr);
;     355 
;     356 
;     357 /*****************************************************
;     358 TCP Functions
;     359 *****************************************************/
;     360 
;     361 void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no);
;     362 unsigned char Listen_TCP(unsigned char socket_no);
;     363 unsigned char Connect_TCP(unsigned char socket_no);
;     364 unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no);
;     365 unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no);
;     366 unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no);
;     367 unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no);
;     368 void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address );
;     369 void sock_close(unsigned char socket_type,unsigned char socket_no);
;     370 void check_disconnect(unsigned char socket_type,unsigned char socket_no);
;     371 void disconnect(unsigned char socket_type,unsigned char socket_no);
;     372 void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet);
;     373 unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet);
;     374 
;     375 /*****************************************************
;     376 Storing
;     377 *****************************************************/
;     378 void store(unsigned char *src,unsigned char *dest,unsigned char size);
;     379 void store_int(unsigned char *src,unsigned char *dest,unsigned char size);
;     380 
;     381 void main(void)
;     382 {

	.CSEG
_main:
;     383 unsigned int get_size;
;     384 unsigned char socket_no=0;
;     385 unsigned char config_gateway[4]; //= {192,168,0,1};
;     386 unsigned char config_subnet_mask[4] ;//= {255,255,255,0};
;     387 unsigned char config_mac_address[6] ;//= {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
;     388 unsigned char config_ip_address[4] ;//= {192,168,0,3};
;     389 unsigned char config_dst_ip_address[4]; //= {192,168,0,5};
;     390 unsigned char default_config_gateway[4]= {192,168,0,1};
;     391 unsigned char default_config_subnet_mask[4] = {255,255,255,0};
;     392 unsigned char default_config_mac_address[6] = {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
;     393 unsigned char default_config_ip_address[4] = {192,168,0,3};
;     394 unsigned char default_config_dst_ip_address[4]= {192,168,0,5};
;     395 unsigned char config_dst_port_address[] = {0,18};
;     396 unsigned char pass[4];
;     397 int i=0,j=0;
;     398 unsigned char a,b,c;
;     399 unsigned char buf[20];
;     400 unsigned char h,m,s;
;     401 unsigned char d,mm,y;
;     402 unsigned char minutes;
;     403 unsigned char h_temp,m_temp,s_temp;
;     404 unsigned char d_temp,mm_temp,y_temp;
;     405 unsigned int buf2[20];
;     406 unsigned char mode;
;     407 unsigned char Authentication=0;
;     408 unsigned char ack1[2]={'O','K'};
;     409 unsigned char ack2[9]={'I','n','s','e','r','t',' ','I','P'};
;     410 unsigned char ack3[8]={'H','o','w',' ','l','o','n','g'};
;     411 unsigned char alarm1[13]={'M','o','t','i','o','n',' ','S','e','n','s','e','d'};
;     412 unsigned char count1,count2,count3,stage=1;
;     413 unsigned char dest_ip_temp[4];
;     414 
;     415 
;     416 
;     417 rtc_init(1,1,3);
	SBIW R28,63
	SBIW R28,63
	SBIW R28,43
	LDI  R24,143
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0x3*2)
	LDI  R31,HIGH(_0x3*2)
	CALL __INITLOCB
;	get_size -> R16,R17
;	socket_no -> R19
;	config_gateway -> Y+165
;	config_subnet_mask -> Y+161
;	config_mac_address -> Y+155
;	config_ip_address -> Y+151
;	config_dst_ip_address -> Y+147
;	default_config_gateway -> Y+143
;	default_config_subnet_mask -> Y+139
;	default_config_mac_address -> Y+133
;	default_config_ip_address -> Y+129
;	default_config_dst_ip_address -> Y+125
;	config_dst_port_address -> Y+123
;	pass -> Y+119
;	i -> R20,R21
;	j -> Y+117
;	a -> R18
;	b -> Y+116
;	c -> Y+115
;	buf -> Y+95
;	h -> Y+94
;	m -> Y+93
;	s -> Y+92
;	d -> Y+91
;	mm -> Y+90
;	y -> Y+89
;	minutes -> Y+88
;	h_temp -> Y+87
;	m_temp -> Y+86
;	s_temp -> Y+85
;	d_temp -> Y+84
;	mm_temp -> Y+83
;	y_temp -> Y+82
;	buf2 -> Y+42
;	mode -> Y+41
;	Authentication -> Y+40
;	ack1 -> Y+38
;	ack2 -> Y+29
;	ack3 -> Y+21
;	alarm1 -> Y+8
;	count1 -> Y+7
;	count2 -> Y+6
;	count3 -> Y+5
;	stage -> Y+4
;	dest_ip_temp -> Y+0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _rtc_init
;     418 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     419 
;     420 source_port_number=0x07;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	MOVW R4,R30
;     421 
;     422 initialize();
	RCALL _initialize
;     423 
;     424 init:
_0x4:
;     425 
;     426 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     427 lcd_putsf("To insert num");
	__POINTW1FN _0,0
	CALL SUBOPT_0x0
;     428 lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     429 lcd_putsf("     twice");
	__POINTW1FN _0,14
	CALL SUBOPT_0x0
;     430 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x2
;     431 lcd_clear();
;     432 lcd_putsf("Insert * ");
	__POINTW1FN _0,25
	CALL SUBOPT_0x0
;     433 lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     434 lcd_putsf("eg:2* for 22");
	__POINTW1FN _0,35
	CALL SUBOPT_0x0
;     435 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0x2
;     436 lcd_clear();
;     437 lcd_putsf("Pick 4 nums pass");
	__POINTW1FN _0,48
	CALL SUBOPT_0x0
;     438 
;     439 
;     440 
;     441 while(1)
_0x5:
;     442 {
;     443 
;     444 co1omn1:
_0x8:
;     445 c=a;
	__PUTBSRX 115,18
;     446  //first column
;     447 PORTC =0x7f;//0111
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     448 
;     449 //check for rows
;     450 if     (!CHECKBIT(PINC,3)) { a=13;goto result;}
	SBIC 0x13,3
	RJMP _0x9
	LDI  R18,LOW(13)
	RJMP _0xA
;     451 else if(!CHECKBIT(PINC,2)) { a=2;goto result; }
_0x9:
	SBIC 0x13,2
	RJMP _0xC
	LDI  R18,LOW(2)
	RJMP _0xA
;     452 else if(!CHECKBIT(PINC,1)) { a=3;goto result; }
_0xC:
	SBIC 0x13,1
	RJMP _0xE
	LDI  R18,LOW(3)
	RJMP _0xA
;     453 else if(!CHECKBIT(PINC,0)) { a=4;goto result; }
_0xE:
	SBIC 0x13,0
	RJMP _0x10
	LDI  R18,LOW(4)
	RJMP _0xA
;     454 else goto co1omn2;
_0x10:
;     455 co1omn2:
;     456 //second column
;     457 PORTC =0xbf;//1011
	LDI  R30,LOW(191)
	OUT  0x15,R30
;     458 if     (!CHECKBIT(PINC,3)) { a=1;goto result; }
	SBIC 0x13,3
	RJMP _0x13
	LDI  R18,LOW(1)
	RJMP _0xA
;     459 else if(!CHECKBIT(PINC,2)) { a=6;goto result; }
_0x13:
	SBIC 0x13,2
	RJMP _0x15
	LDI  R18,LOW(6)
	RJMP _0xA
;     460 else if(!CHECKBIT(PINC,1)) { a=7;goto result; }
_0x15:
	SBIC 0x13,1
	RJMP _0x17
	LDI  R18,LOW(7)
	RJMP _0xA
;     461 else if(!CHECKBIT(PINC,0)) { a=8;goto result; }
_0x17:
	SBIC 0x13,0
	RJMP _0x19
	LDI  R18,LOW(8)
	RJMP _0xA
;     462 else goto co1omn3;
_0x19:
;     463 co1omn3:
;     464 //third column
;     465 PORTC =0xdf;//1101
	LDI  R30,LOW(223)
	OUT  0x15,R30
;     466 if     (!CHECKBIT(PINC,3)) { a=5;goto result;  }
	SBIC 0x13,3
	RJMP _0x1C
	LDI  R18,LOW(5)
	RJMP _0xA
;     467 else if(!CHECKBIT(PINC,2)) { a=10;goto result; }
_0x1C:
	SBIC 0x13,2
	RJMP _0x1E
	LDI  R18,LOW(10)
	RJMP _0xA
;     468 else if(!CHECKBIT(PINC,1)) { a=11;goto result; }
_0x1E:
	SBIC 0x13,1
	RJMP _0x20
	LDI  R18,LOW(11)
	RJMP _0xA
;     469 else if(!CHECKBIT(PINC,0)) { a=12;goto result; }
_0x20:
	SBIC 0x13,0
	RJMP _0x22
	LDI  R18,LOW(12)
	RJMP _0xA
;     470 else goto co1omn4;
_0x22:
;     471 co1omn4:
;     472 //fourth column
;     473 PORTC =0xef;//1110
	LDI  R30,LOW(239)
	OUT  0x15,R30
;     474 if	   (!CHECKBIT(PINC,3)) { a=9;goto result;  }
	SBIC 0x13,3
	RJMP _0x25
	LDI  R18,LOW(9)
	RJMP _0xA
;     475 else if(!CHECKBIT(PINC,2)) { a=14;goto result; }
_0x25:
	SBIC 0x13,2
	RJMP _0x27
	LDI  R18,LOW(14)
	RJMP _0xA
;     476 else if(!CHECKBIT(PINC,1)) { a=15;goto result; }
_0x27:
	SBIC 0x13,1
	RJMP _0x29
	LDI  R18,LOW(15)
	RJMP _0xA
;     477 else if(!CHECKBIT(PINC,0)) { a=16;goto result; }
_0x29:
	SBIC 0x13,0
	RJMP _0x2B
	LDI  R18,LOW(16)
	RJMP _0xA
;     478 else goto co1omn1;
_0x2B:
	RJMP _0x8
;     479 
;     480 result:
_0xA:
;     481 
;     482 if(c!=a)
	__GETB2SX 115
	CP   R18,R26
	BRNE PC+3
	JMP _0x2D
;     483 {
;     484 
;     485 if(a==1)  {b=1;sprintf(buf,"%d", b);   lcd_puts(buf);}
	CPI  R18,1
	BRNE _0x2E
	LDI  R30,LOW(1)
	CALL SUBOPT_0x3
;     486 if(a==2)  {b=4;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x2E:
	CPI  R18,2
	BRNE _0x2F
	LDI  R30,LOW(4)
	CALL SUBOPT_0x3
;     487 if(a==3)  {b=7;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x2F:
	CPI  R18,3
	BRNE _0x30
	LDI  R30,LOW(7)
	CALL SUBOPT_0x3
;     488 if(a==4)  {b='*';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x30:
	CPI  R18,4
	BRNE _0x31
	LDI  R30,LOW(42)
	CALL SUBOPT_0x4
;     489 if(a==5)  {b=2;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x31:
	CPI  R18,5
	BRNE _0x32
	LDI  R30,LOW(2)
	CALL SUBOPT_0x3
;     490 if(a==6)  {b=5;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x32:
	CPI  R18,6
	BRNE _0x33
	LDI  R30,LOW(5)
	CALL SUBOPT_0x3
;     491 if(a==7)  {b=8;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x33:
	CPI  R18,7
	BRNE _0x34
	LDI  R30,LOW(8)
	CALL SUBOPT_0x3
;     492 if(a==8)  {b=0;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x34:
	CPI  R18,8
	BRNE _0x35
	LDI  R30,LOW(0)
	CALL SUBOPT_0x3
;     493 if(a==9)  {b=3;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x35:
	CPI  R18,9
	BRNE _0x36
	LDI  R30,LOW(3)
	CALL SUBOPT_0x3
;     494 if(a==10) {b=6;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x36:
	CPI  R18,10
	BRNE _0x37
	LDI  R30,LOW(6)
	CALL SUBOPT_0x3
;     495 if(a==11) {b=9;sprintf(buf,"%d", b);   lcd_puts(buf);}
_0x37:
	CPI  R18,11
	BRNE _0x38
	LDI  R30,LOW(9)
	CALL SUBOPT_0x3
;     496 if(a==12) {b='.';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x38:
	CPI  R18,12
	BRNE _0x39
	LDI  R30,LOW(46)
	CALL SUBOPT_0x4
;     497 if(a==13) {b='A';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x39:
	CPI  R18,13
	BRNE _0x3A
	LDI  R30,LOW(65)
	CALL SUBOPT_0x4
;     498 if(a==14) {b='B';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x3A:
	CPI  R18,14
	BRNE _0x3B
	LDI  R30,LOW(66)
	CALL SUBOPT_0x4
;     499 if(a==15) {b='C';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x3B:
	CPI  R18,15
	BRNE _0x3C
	LDI  R30,LOW(67)
	CALL SUBOPT_0x4
;     500 if(a==16) {b='D';sprintf(buf,"%c", b); lcd_puts(buf);}
_0x3C:
	CPI  R18,16
	BRNE _0x3D
	LDI  R30,LOW(68)
	CALL SUBOPT_0x4
;     501 
;     502 begin:
_0x3D:
_0x3E:
;     503 
;     504 switch(i)
	MOVW R30,R20
;     505 {
;     506 case 0:
	SBIW R30,0
	BRNE _0x42
;     507     {
;     508     pass[j++]=b;
	CALL SUBOPT_0x5
	MOVW R26,R28
	SUBI R26,LOW(-(119))
	SBCI R27,HIGH(-(119))
	ADD  R30,R26
	ADC  R31,R27
	__GETB2SX 116
	STD  Z+0,R26
;     509     if(j==4)
	CALL SUBOPT_0x6
	SBIW R26,4
	BRNE _0x43
;     510         {
;     511         i++;
	__ADDWRN 20,21,1
;     512         lcd_clear();
	CALL SUBOPT_0x7
;     513         lcd_putsf("Set Date");
;     514         lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     515         lcd_putsf("Day/Month/Year");
	__POINTW1FN _0,80
	CALL SUBOPT_0x0
;     516         j=0;
	CALL SUBOPT_0x8
;     517         }
;     518     goto co1omn1;
_0x43:
	RJMP _0x8
;     519     }
;     520 
;     521 case 1:
_0x42:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x45
;     522     {
;     523     buf2[j++]=b;      //Store the values to be written to the timekeeper DS1302
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     524         if(j==1)
	CALL SUBOPT_0x6
	SBIW R26,1
	BRNE _0x46
;     525         {
;     526             lcd_clear();
	CALL SUBOPT_0xB
;     527             lcd_puts(buf);
;     528         }
;     529 
;     530         if(j==6)
_0x46:
	CALL SUBOPT_0x6
	SBIW R26,6
	BRNE _0x47
;     531         {
;     532         lcd_clear();
	CALL SUBOPT_0x7
;     533         lcd_putsf("Set Date");
;     534         lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     535         lcd_putsf("Hour/Min/Sec");
	__POINTW1FN _0,95
	CALL SUBOPT_0x0
;     536         }
;     537         if(j==7)
_0x47:
	CALL SUBOPT_0x6
	SBIW R26,7
	BRNE _0x48
;     538         {
;     539             lcd_clear();
	CALL SUBOPT_0xB
;     540             lcd_puts(buf);
;     541         }
;     542 
;     543         if(j==12)
_0x48:
	CALL SUBOPT_0x6
	SBIW R26,12
	BREQ PC+3
	JMP _0x49
;     544         {
;     545             lcd_clear();
	CALL _lcd_clear
;     546             for(j=0;j<12;j++)
	CALL SUBOPT_0x8
_0x4B:
	CALL SUBOPT_0x6
	SBIW R26,12
	BRGE _0x4C
;     547             {
;     548                 if(buf2[j]=='*')
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
	SBIW R30,42
	BRNE _0x4D
;     549                     buf2[j]=buf2[j-1];
	CALL SUBOPT_0xC
	CALL SUBOPT_0xE
	SBIW R30,1
	CALL SUBOPT_0x9
	CALL SUBOPT_0xD
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     550             }
_0x4D:
	CALL SUBOPT_0xF
	RJMP _0x4B
_0x4C:
;     551             i++;
	__ADDWRN 20,21,1
;     552             j=0;
	CALL SUBOPT_0x8
;     553             rtc_set_date((buf2[j]*10+buf2[j+1]),(buf2[j+2]*10+buf2[j+3]),(buf2[j+4]*10+buf2[j+5]));
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
	CALL SUBOPT_0x10
	CALL SUBOPT_0x11
	ADIW R30,1
	CALL SUBOPT_0x9
	CALL SUBOPT_0xD
	CALL SUBOPT_0x12
	ADIW R30,2
	CALL SUBOPT_0x13
	CALL SUBOPT_0x10
	CALL SUBOPT_0x14
	ADIW R30,3
	CALL SUBOPT_0x13
	CALL SUBOPT_0x15
	ADIW R30,4
	CALL SUBOPT_0x16
	CALL SUBOPT_0x10
	CALL SUBOPT_0x17
	ADIW R30,5
	CALL SUBOPT_0x16
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R30
	CALL _rtc_set_date
;     554             rtc_set_time((buf2[j+6]*10+buf2[j+7]),(buf2[j+8]*10+buf2[j+9]),(buf2[j+10]*10+buf[j+11]));
	CALL SUBOPT_0x11
	ADIW R30,6
	CALL SUBOPT_0x9
	CALL SUBOPT_0xD
	CALL SUBOPT_0x10
	CALL SUBOPT_0x11
	ADIW R30,7
	CALL SUBOPT_0x9
	CALL SUBOPT_0xD
	CALL SUBOPT_0x12
	ADIW R30,8
	CALL SUBOPT_0x13
	CALL SUBOPT_0x10
	CALL SUBOPT_0x14
	ADIW R30,9
	CALL SUBOPT_0x13
	CALL SUBOPT_0x15
	ADIW R30,10
	CALL SUBOPT_0x16
	CALL SUBOPT_0x10
	CALL SUBOPT_0x17
	ADIW R30,11
	MOVW R26,R28
	SUBI R26,LOW(-(97))
	SBCI R27,HIGH(-(97))
	CALL SUBOPT_0x18
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R30
	CALL _rtc_set_time
;     555             lcd_putsf("Set IPs ? y/n");
	__POINTW1FN _0,108
	CALL SUBOPT_0x0
;     556             //lcd_putsf("Set IP Address");
;     557             lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     558             lcd_putsf("y=1/n=2");
	__POINTW1FN _0,122
	CALL SUBOPT_0x0
;     559         }
;     560 
;     561     goto co1omn1;
_0x49:
	RJMP _0x8
;     562 
;     563     }
;     564 
;     565 case 2:
_0x45:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x4F
;     566     {
;     567     buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     568     if(buf2[j-1]==1)
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	SBIW R30,1
	BRNE _0x50
;     569         {
;     570         i++;
	__ADDWRN 20,21,1
;     571         lcd_putsf("Set IP Address");
	__POINTW1FN _0,130
	CALL SUBOPT_0x0
;     572         lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     573 
;     574         }
;     575     else if(buf2[j-1]==2)    //use defaults
	RJMP _0x51
_0x50:
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	SBIW R30,2
	BREQ PC+3
	JMP _0x52
;     576         {
;     577         for(j=0;j<4;j++)
	CALL SUBOPT_0x8
_0x54:
	CALL SUBOPT_0x6
	SBIW R26,4
	BRGE _0x55
;     578             {
;     579             config_gateway[j]=default_config_gateway[j];
	CALL SUBOPT_0x11
	MOVW R26,R28
	SUBI R26,LOW(-(165))
	SBCI R27,HIGH(-(165))
	CALL SUBOPT_0xE
	MOVW R26,R28
	SUBI R26,LOW(-(143))
	SBCI R27,HIGH(-(143))
	CALL SUBOPT_0x1A
;     580             config_subnet_mask[j] = default_config_subnet_mask[j];
	MOVW R26,R28
	SUBI R26,LOW(-(161))
	SBCI R27,HIGH(-(161))
	CALL SUBOPT_0xE
	MOVW R26,R28
	SUBI R26,LOW(-(139))
	SBCI R27,HIGH(-(139))
	CALL SUBOPT_0x1A
;     581             config_ip_address[j] = default_config_ip_address[j] ;
	MOVW R26,R28
	SUBI R26,LOW(-(151))
	SBCI R27,HIGH(-(151))
	CALL SUBOPT_0xE
	MOVW R26,R28
	SUBI R26,LOW(-(129))
	SBCI R27,HIGH(-(129))
	CALL SUBOPT_0x1A
;     582             config_dst_ip_address[j]= default_config_dst_ip_address[j];
	MOVW R26,R28
	SUBI R26,LOW(-(147))
	SBCI R27,HIGH(-(147))
	CALL SUBOPT_0xE
	MOVW R26,R28
	SUBI R26,LOW(-(125))
	SBCI R27,HIGH(-(125))
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
;     583             }
	CALL SUBOPT_0xF
	RJMP _0x54
_0x55:
;     584         for(j=0;j<6;j++)
	CALL SUBOPT_0x8
_0x57:
	CALL SUBOPT_0x6
	SBIW R26,6
	BRGE _0x58
;     585             config_mac_address[j]=default_config_mac_address[j];
	CALL SUBOPT_0x11
	MOVW R26,R28
	SUBI R26,LOW(-(155))
	SBCI R27,HIGH(-(155))
	CALL SUBOPT_0xE
	MOVW R26,R28
	SUBI R26,LOW(-(133))
	SBCI R27,HIGH(-(133))
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
;     586         }
	CALL SUBOPT_0xF
	RJMP _0x57
_0x58:
;     587     else
	RJMP _0x59
_0x52:
;     588         {
;     589         i=0;
	__GETWRN 20,21,0
;     590         lcd_putsf("Error");
	__POINTW1FN _0,145
	CALL SUBOPT_0x0
;     591         lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     592         goto init;
	RJMP _0x4
;     593         }
_0x59:
_0x51:
;     594         j=0;
	CALL SUBOPT_0x8
;     595     goto co1omn1;
	RJMP _0x8
;     596     }
;     597 
;     598 case 3:
_0x4F:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x5B
;     599     {   //set ip address
;     600         buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     601         if(buf2[j-1]=='A')          //termination
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x5C
;     602         {
;     603             lcd_clear();
	CALL SUBOPT_0x1B
;     604             i++;
;     605             j=0;
	CALL SUBOPT_0x8
;     606             store(buf2,config_ip_address,j);
	CALL SUBOPT_0x1C
	MOVW R30,R28
	SUBI R30,LOW(-(153))
	SBCI R31,HIGH(-(153))
	CALL SUBOPT_0x1D
;     607 
;     608             lcd_putsf("Subnet Mask");
	__POINTW1FN _0,151
	CALL SUBOPT_0x0
;     609             lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     610 
;     611         }
;     612 
;     613 
;     614 
;     615 
;     616 
;     617         goto co1omn1;
_0x5C:
	RJMP _0x8
;     618     }
;     619 case 4:
_0x5B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x5E
;     620     {
;     621         buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     622         if(buf2[j-1]=='A')          //termination
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x5F
;     623         {
;     624             lcd_clear();
	CALL SUBOPT_0x1B
;     625             i++;
;     626             store(buf2,config_subnet_mask,j);
	CALL SUBOPT_0x1C
	MOVW R30,R28
	SUBI R30,LOW(-(163))
	SBCI R31,HIGH(-(163))
	CALL SUBOPT_0x1D
;     627 
;     628             lcd_putsf("Default Gateway");
	__POINTW1FN _0,163
	CALL SUBOPT_0x0
;     629             lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     630             j=0;
	CALL SUBOPT_0x8
;     631 
;     632         }
;     633         goto co1omn1;
_0x5F:
	RJMP _0x8
;     634     }
;     635 
;     636 case 5:
_0x5E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x61
;     637     {
;     638         buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     639         if(buf2[j-1]=='A')          //termination
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x62
;     640         {
;     641             lcd_clear();
	CALL SUBOPT_0x1B
;     642             i++;
;     643             store(buf2,config_gateway,j);
	CALL SUBOPT_0x1C
	MOVW R30,R28
	SUBI R30,LOW(-(167))
	SBCI R31,HIGH(-(167))
	CALL SUBOPT_0x1D
;     644 
;     645             lcd_putsf("Set Mac Address");
	__POINTW1FN _0,179
	CALL SUBOPT_0x0
;     646             lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     647             j=0;
	CALL SUBOPT_0x8
;     648 
;     649         }
;     650         goto co1omn1;
_0x62:
	RJMP _0x8
;     651     }
;     652 
;     653 case 6:
_0x61:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x64
;     654     {
;     655         buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     656         if(buf2[j-1]=='A')          //termination
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x65
;     657         {
;     658             lcd_clear();
	CALL SUBOPT_0x1B
;     659             i++;
;     660             store(buf2,config_mac_address,j);
	CALL SUBOPT_0x1C
	MOVW R30,R28
	SUBI R30,LOW(-(157))
	SBCI R31,HIGH(-(157))
	CALL SUBOPT_0x1D
;     661 
;     662             lcd_putsf("Server Address");
	__POINTW1FN _0,195
	CALL SUBOPT_0x0
;     663             lcd_gotoxy(0,1);
	CALL SUBOPT_0x1
;     664             j=0;
	CALL SUBOPT_0x8
;     665 
;     666         }
;     667         goto co1omn1;
_0x65:
	RJMP _0x8
;     668 
;     669     }
;     670 case 7:
_0x64:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x67
;     671     {
;     672         buf2[j++]=b;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
;     673         if(buf2[j-1]=='A')          //termination
	CALL SUBOPT_0x19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x68
;     674         {
;     675             lcd_clear();
	CALL SUBOPT_0x1B
;     676             i++;
;     677             store(buf2,config_dst_ip_address,j);
	CALL SUBOPT_0x1C
	MOVW R30,R28
	SUBI R30,LOW(-(149))
	SBCI R31,HIGH(-(149))
	CALL SUBOPT_0x1D
;     678             goto begin;
	RJMP _0x3E
;     679 
;     680         }
;     681 
;     682     }
_0x68:
;     683 case 8:
	RJMP _0x69
_0x67:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x41
_0x69:
;     684     {
;     685     lcd_clear();
	CALL _lcd_clear
;     686     lcd_putsf("Starting........");
	__POINTW1FN _0,210
	CALL SUBOPT_0x0
;     687     goto tcp;
	RJMP _0x6B
;     688     }
;     689 
;     690 
;     691 }//end switch
_0x41:
;     692 }//end if
;     693 }//end keypad loop
_0x2D:
	RJMP _0x5
;     694 
;     695 
;     696 /*****************************************************
;     697 Initializition
;     698 *****************************************************/
;     699 
;     700 operate:
;     701 
;     702   setGAR(config_gateway);              // Set default gateway
;     703   setSUBR(config_subnet_mask);         // Set subnet mask
;     704   setSHAR(config_mac_address);         // Set mac address
;     705   setSIPR(config_ip_address);          // Set ip address
;     706 
;     707   Alarm=0;
;     708 
;     709 tcp:
_0x6B:
;     710 
;     711 
;     712 open_socket(TCP,Sock0,source_port_number);      //open a TCP socket
	CALL SUBOPT_0x1E
	ST   -Y,R5
	ST   -Y,R4
	RCALL _open_socket
;     713 
;     714 while (1)
_0x6D:
;     715 {
;     716 
;     717 
;     718 
;     719 if(Alarm)                                       //if Alarm is detected -> connect to server
	SBIS 0x10,2
	RJMP _0x70
;     720 {
;     721     client_mode:
;     722         mode=1;
	LDI  R30,LOW(1)
	STD  Y+41,R30
;     723         wr_dst_addr_TCP(Sock0,config_dst_ip_address,config_dst_port_address);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(148))
	SBCI R31,HIGH(-(148))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(126))
	SBCI R31,HIGH(-(126))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _wr_dst_addr_TCP
;     724         Connect_TCP(Sock0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Connect_TCP
;     725 }
;     726 else
	RJMP _0x72
_0x70:
;     727 {
;     728     server_mode:
;     729         mode=2;
	LDI  R30,LOW(2)
	STD  Y+41,R30
;     730         Listen_TCP(Sock0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Listen_TCP
;     731         while (wiz_rd(Sn_SR(Sock0)) == SOCK_LISTEN)
_0x74:
	CALL SUBOPT_0x1F
	CPI  R30,LOW(0x14)
	BRNE _0x76
;     732             {
;     733                 if(Alarm)                                       //if Alarm is detected -> connect to server
	SBIS 0x10,2
	RJMP _0x77
;     734                 {
;     735                 lcd_clear();
	CALL SUBOPT_0x20
;     736                 lcd_putsf("Alarm Detected");
;     737                 goto tcp;
	RJMP _0x6B
;     738                 }
;     739             };    //wait for request
_0x77:
	RJMP _0x74
_0x76:
;     740 }
_0x72:
;     741 
;     742 
;     743 /*****************************************************
;     744 Reading
;     745 *****************************************************/
;     746 
;     747 
;     748   while (wiz_rd(Sn_SR(Sock0)) == SOCK_ESTABLISHED)
_0x78:
	CALL SUBOPT_0x1F
	CPI  R30,LOW(0x17)
	BREQ PC+3
	JMP _0x7A
;     749   {
;     750     Listen:
_0x7B:
;     751     if(Alarm)                                       //if Alarm is detected -> connect to server
	SBIS 0x10,2
	RJMP _0x7C
;     752     {
;     753         lcd_clear();
	CALL SUBOPT_0x20
;     754         lcd_putsf("Alarm Detected");
;     755         goto tcp;
	RJMP _0x6B
;     756     }
;     757     else
_0x7C:
;     758         if(mode==1)//  && !Alarm                  //souhld be rare but possible              //if mode ==1 and there is no alarm
	LDD  R26,Y+41
	CPI  R26,LOW(0x1)
	BREQ _0x6B
;     759         goto tcp;
;     760     lcd_clear();
	CALL _lcd_clear
;     761     lcd_putsf("Waiting for data");
	__POINTW1FN _0,242
	CALL SUBOPT_0x0
;     762 
;     763     rtc_get_date(&d,&mm,&y);
	CALL SUBOPT_0x21
;     764 	rtc_get_time(&h,&m,&s);
;     765 
;     766     if(h==h_temp && m>(m_temp+15+minutes) )           //If 15 minutes spent after alarm was detected and remained ,, retransmit alarm for other 5 minutes
	BRNE _0x80
	__GETB1SX 86
	SUBI R30,-LOW(15)
	__GETB2SX 88
	ADD  R30,R26
	CALL SUBOPT_0x22
	CP   R30,R26
	BRLO _0x81
_0x80:
	RJMP _0x7F
_0x81:
;     767         {
;     768         count2=1;                             //reset timing
	LDI  R30,LOW(1)
	STD  Y+6,R30
;     769         goto send_alarm;
	RJMP _0x82
;     770         }
;     771 
;     772   if(mode==2)                                       //if acting like a server eg: no alarm detected
_0x7F:
	LDD  R26,Y+41
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x83
;     773    while (wiz_rd(Sn_RX_RSR0(socket_no)) != 0 || wiz_rd(Sn_RX_RSR1(socket_no)) != 0)  //Check to know if data is received from remote peer or not.
_0x84:
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CPI  R30,0
	BRNE _0x87
	CALL SUBOPT_0x23
	CALL SUBOPT_0x25
	CPI  R30,0
	BRNE _0x87
	RJMP _0x86
_0x87:
;     774    {
;     775     if(Alarm)                                       //if Alarm is detected -> connect to server
	SBIC 0x10,2
;     776     {
;     777         goto tcp;
	RJMP _0x6B
;     778     }
;     779 
;     780     get_size=recieve(TCP,Sock0,packet);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x26
	RCALL _recieve
	MOV  R16,R30
	CLR  R17
;     781     if(!get_size)   goto exit;
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x8A
	RJMP _0x8B
;     782 
;     783 if(!count1)                                   //if it is first attempt
_0x8A:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x8C
;     784 if(packet[TCP_data]==pass[0])
	__GETB2MN _packet,54
	__GETB1SX 119
	CP   R30,R26
	BRNE _0x8D
;     785 if(packet[TCP_data+1]==pass[1])
	__GETB2MN _packet,55
	__GETB1SX 120
	CP   R30,R26
	BRNE _0x8E
;     786 if(packet[TCP_data+2]==pass[2])
	__GETB2MN _packet,56
	__GETB1SX 121
	CP   R30,R26
	BRNE _0x8F
;     787 if(packet[TCP_data+3]==pass[3])
	__GETB2MN _packet,57
	__GETB1SX 122
	CP   R30,R26
	BRNE _0x90
;     788     {
;     789     Authentication=1;               //password is correct
	LDI  R30,LOW(1)
	STD  Y+40,R30
;     790     count1=1;
	STD  Y+7,R30
;     791     for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0x92:
	__CPWRN 20,21,2
	BRGE _0x93
;     792     {
;     793     packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     794     }
	__ADDWRN 20,21,1
	RJMP _0x92
_0x93:
;     795     transmit(TCP,Sock0,2,packet);   //ack as OK
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     796     goto Listen;
	RJMP _0x7B
;     797     }
;     798 
;     799 
;     800 
;     801 if(Authentication)                   //Start executing Commands
_0x90:
_0x8F:
_0x8E:
_0x8D:
_0x8C:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0x94
;     802 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x95
;     803 if(packet[TCP_data]=='d')         //first command "dstip change"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x64)
	BREQ PC+3
	JMP _0x96
;     804 if(packet[TCP_data+1]=='s')         //response is "Insert IP"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x73)
	BREQ PC+3
	JMP _0x97
;     805 if(packet[TCP_data+2]=='t')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x74)
	BRNE _0x98
;     806 if(packet[TCP_data+3]=='i')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x69)
	BRNE _0x99
;     807 if(packet[TCP_data+4]=='p')
	__GETB1MN _packet,58
	CPI  R30,LOW(0x70)
	BRNE _0x9A
;     808 if(packet[TCP_data+5]==' ')
	__GETB1MN _packet,59
	CPI  R30,LOW(0x20)
	BRNE _0x9B
;     809 if(packet[TCP_data+6]=='c')
	__GETB1MN _packet,60
	CPI  R30,LOW(0x63)
	BRNE _0x9C
;     810 if(packet[TCP_data+7]=='h')
	__GETB1MN _packet,61
	CPI  R30,LOW(0x68)
	BRNE _0x9D
;     811 if(packet[TCP_data+8]=='a')
	__GETB1MN _packet,62
	CPI  R30,LOW(0x61)
	BRNE _0x9E
;     812 if(packet[TCP_data+9]=='n')
	__GETB1MN _packet,63
	CPI  R30,LOW(0x6E)
	BRNE _0x9F
;     813 if(packet[TCP_data+10]=='g')
	__GETB1MN _packet,64
	CPI  R30,LOW(0x67)
	BRNE _0xA0
;     814 if(packet[TCP_data+11]=='e')
	__GETB1MN _packet,65
	CPI  R30,LOW(0x65)
	BRNE _0xA1
;     815     {
;     816     for(i=0;i<9;i++)
	__GETWRN 20,21,0
_0xA3:
	__CPWRN 20,21,9
	BRGE _0xA4
;     817     {
;     818     packet[TCP_data+i]=ack2[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x2A
;     819     }
	__ADDWRN 20,21,1
	RJMP _0xA3
_0xA4:
;     820     transmit(TCP,Sock0,9,packet);
	CALL SUBOPT_0x1E
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL SUBOPT_0x26
	RCALL _transmit
;     821     stage++;
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
;     822     goto Listen;
	RJMP _0x7B
;     823     }
;     824 
;     825 if(Authentication)                           //Get New destination IP number
_0xA1:
_0xA0:
_0x9F:
_0x9E:
_0x9D:
_0x9C:
_0x9B:
_0x9A:
_0x99:
_0x98:
_0x97:
_0x96:
_0x95:
_0x94:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0xA5
;     826 if(stage==2)
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0xA6
;     827 {
;     828 j=15;
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	__PUTW1SX 117
;     829 for(i=0;packet[TCP_data+i]!=' ';i++)
	__GETWRN 20,21,0
_0xA8:
	MOVW R30,R20
	__ADDW1MN _packet,54
	LD   R30,Z
	CPI  R30,LOW(0x20)
	BREQ _0xA9
;     830 {
;     831 dest_ip_temp[i]=packet[TCP_data+i];
	MOVW R26,R28
	ADD  R26,R20
	ADC  R27,R21
	MOVW R30,R20
	__ADDW1MN _packet,54
	LD   R30,Z
	ST   X,R30
;     832 };
	__ADDWRN 20,21,1
	RJMP _0xA8
_0xA9:
;     833 dest_ip_temp[i]=' ';//add terminator         //i=size
	MOVW R26,R28
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(32)
	ST   X,R30
;     834 
;     835 store_int(dest_ip_temp,config_dst_ip_address,i);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(149))
	SBCI R31,HIGH(-(149))
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R20
	RCALL _store_int
;     836 for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xAB:
	__CPWRN 20,21,2
	BRGE _0xAC
;     837 {
;     838 packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     839 }
	__ADDWRN 20,21,1
	RJMP _0xAB
_0xAC:
;     840 transmit(TCP,Sock0,2,packet);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     841 stage=1;
	LDI  R30,LOW(1)
	STD  Y+4,R30
;     842 goto Listen;                        //wait further commands
	RJMP _0x7B
;     843 }
;     844 
;     845 
;     846 if(Authentication)                   //Start executing Commands
_0xA6:
_0xA5:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0xAD
;     847 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xAE
;     848 if(packet[TCP_data]=='t')         //second command "turn on lights"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x74)
	BREQ PC+3
	JMP _0xAF
;     849 if(packet[TCP_data+1]=='u')         //response is "OK"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x75)
	BRNE _0xB0
;     850 if(packet[TCP_data+2]=='r')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x72)
	BRNE _0xB1
;     851 if(packet[TCP_data+3]=='n')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x6E)
	BRNE _0xB2
;     852 if(packet[TCP_data+4]=='o')
	__GETB1MN _packet,58
	CPI  R30,LOW(0x6F)
	BRNE _0xB3
;     853 if(packet[TCP_data+5]=='n')
	__GETB1MN _packet,59
	CPI  R30,LOW(0x6E)
	BRNE _0xB4
;     854 if(packet[TCP_data+6]==' ')
	__GETB1MN _packet,60
	CPI  R30,LOW(0x20)
	BRNE _0xB5
;     855 if(packet[TCP_data+7]=='l')
	__GETB1MN _packet,61
	CPI  R30,LOW(0x6C)
	BRNE _0xB6
;     856 if(packet[TCP_data+8]=='i')
	__GETB1MN _packet,62
	CPI  R30,LOW(0x69)
	BRNE _0xB7
;     857 if(packet[TCP_data+9]=='g')
	__GETB1MN _packet,63
	CPI  R30,LOW(0x67)
	BRNE _0xB8
;     858 if(packet[TCP_data+10]=='h')
	__GETB1MN _packet,64
	CPI  R30,LOW(0x68)
	BRNE _0xB9
;     859 if(packet[TCP_data+11]=='t')
	__GETB1MN _packet,65
	CPI  R30,LOW(0x74)
	BRNE _0xBA
;     860     {
;     861     light =1;
	SBI  0x12,4
;     862     for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xBC:
	__CPWRN 20,21,2
	BRGE _0xBD
;     863     {
;     864     packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     865     }
	__ADDWRN 20,21,1
	RJMP _0xBC
_0xBD:
;     866     transmit(TCP,Sock0,2,packet);   //ack as OK
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     867     goto Listen;
	RJMP _0x7B
;     868     }
;     869 
;     870 
;     871 
;     872 if(Authentication)                   //Start executing Commands
_0xBA:
_0xB9:
_0xB8:
_0xB7:
_0xB6:
_0xB5:
_0xB4:
_0xB3:
_0xB2:
_0xB1:
_0xB0:
_0xAF:
_0xAE:
_0xAD:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0xBE
;     873 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xBF
;     874 if(packet[TCP_data]=='t')         //third command "turn off lights"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x74)
	BREQ PC+3
	JMP _0xC0
;     875 if(packet[TCP_data+1]=='u')         //response is "OK"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x75)
	BREQ PC+3
	JMP _0xC1
;     876 if(packet[TCP_data+2]=='r')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x72)
	BRNE _0xC2
;     877 if(packet[TCP_data+3]=='n')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x6E)
	BRNE _0xC3
;     878 if(packet[TCP_data+4]=='o')
	__GETB1MN _packet,58
	CPI  R30,LOW(0x6F)
	BRNE _0xC4
;     879 if(packet[TCP_data+5]=='f')
	__GETB1MN _packet,59
	CPI  R30,LOW(0x66)
	BRNE _0xC5
;     880 if(packet[TCP_data+6]=='f')
	__GETB1MN _packet,60
	CPI  R30,LOW(0x66)
	BRNE _0xC6
;     881 if(packet[TCP_data+7]==' ')
	__GETB1MN _packet,61
	CPI  R30,LOW(0x20)
	BRNE _0xC7
;     882 if(packet[TCP_data+8]=='l')
	__GETB1MN _packet,62
	CPI  R30,LOW(0x6C)
	BRNE _0xC8
;     883 if(packet[TCP_data+9]=='i')
	__GETB1MN _packet,63
	CPI  R30,LOW(0x69)
	BRNE _0xC9
;     884 if(packet[TCP_data+10]=='g')
	__GETB1MN _packet,64
	CPI  R30,LOW(0x67)
	BRNE _0xCA
;     885 if(packet[TCP_data+11]=='h')
	__GETB1MN _packet,65
	CPI  R30,LOW(0x68)
	BRNE _0xCB
;     886 if(packet[TCP_data+12]=='t')
	__GETB1MN _packet,66
	CPI  R30,LOW(0x74)
	BRNE _0xCC
;     887     {
;     888     light =0;
	CBI  0x12,4
;     889     for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xCE:
	__CPWRN 20,21,2
	BRGE _0xCF
;     890     {
;     891     packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     892     }
	__ADDWRN 20,21,1
	RJMP _0xCE
_0xCF:
;     893     transmit(TCP,Sock0,2,packet);   //ack as OK
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     894     goto Listen;
	RJMP _0x7B
;     895     }
;     896 
;     897 
;     898 if(Authentication)                   //Start executing Commands
_0xCC:
_0xCB:
_0xCA:
_0xC9:
_0xC8:
_0xC7:
_0xC6:
_0xC5:
_0xC4:
_0xC3:
_0xC2:
_0xC1:
_0xC0:
_0xBF:
_0xBE:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0xD0
;     899 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xD1
;     900 if(packet[TCP_data]=='t')         //third command "turn on alarm"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x74)
	BREQ PC+3
	JMP _0xD2
;     901 if(packet[TCP_data+1]=='u')         //response is "OK"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x75)
	BRNE _0xD3
;     902 if(packet[TCP_data+2]=='r')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x72)
	BRNE _0xD4
;     903 if(packet[TCP_data+3]=='n')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x6E)
	BRNE _0xD5
;     904 if(packet[TCP_data+4]=='o')
	__GETB1MN _packet,58
	CPI  R30,LOW(0x6F)
	BRNE _0xD6
;     905 if(packet[TCP_data+5]=='n')
	__GETB1MN _packet,59
	CPI  R30,LOW(0x6E)
	BRNE _0xD7
;     906 if(packet[TCP_data+7]==' ')
	__GETB1MN _packet,61
	CPI  R30,LOW(0x20)
	BRNE _0xD8
;     907 if(packet[TCP_data+8]=='a')
	__GETB1MN _packet,62
	CPI  R30,LOW(0x61)
	BRNE _0xD9
;     908 if(packet[TCP_data+9]=='l')
	__GETB1MN _packet,63
	CPI  R30,LOW(0x6C)
	BRNE _0xDA
;     909 if(packet[TCP_data+10]=='a')
	__GETB1MN _packet,64
	CPI  R30,LOW(0x61)
	BRNE _0xDB
;     910 if(packet[TCP_data+11]=='r')
	__GETB1MN _packet,65
	CPI  R30,LOW(0x72)
	BRNE _0xDC
;     911 if(packet[TCP_data+12]=='m')
	__GETB1MN _packet,66
	CPI  R30,LOW(0x6D)
	BRNE _0xDD
;     912     {
;     913     for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xDF:
	__CPWRN 20,21,2
	BRGE _0xE0
;     914     {
;     915     packet[TCP_data+i]=ack2[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x2A
;     916     }
	__ADDWRN 20,21,1
	RJMP _0xDF
_0xE0:
;     917     minutes=0;
	LDI  R30,LOW(0)
	__PUTB1SX 88
;     918     goto Listen;
	RJMP _0x7B
;     919     }
;     920 
;     921 if(Authentication)                   //Start executing Commands
_0xDD:
_0xDC:
_0xDB:
_0xDA:
_0xD9:
_0xD8:
_0xD7:
_0xD6:
_0xD5:
_0xD4:
_0xD3:
_0xD2:
_0xD1:
_0xD0:
	LDD  R30,Y+40
	CPI  R30,0
	BRNE PC+3
	JMP _0xE1
;     922 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xE2
;     923 if(packet[TCP_data]=='t')         //third command "turn off alarm"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x74)
	BREQ PC+3
	JMP _0xE3
;     924 if(packet[TCP_data+1]=='u')         //response is "How long"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x75)
	BREQ PC+3
	JMP _0xE4
;     925 if(packet[TCP_data+2]=='r')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x72)
	BREQ PC+3
	JMP _0xE5
;     926 if(packet[TCP_data+3]=='n')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x6E)
	BREQ PC+3
	JMP _0xE6
;     927 if(packet[TCP_data+4]=='o')
	__GETB1MN _packet,58
	CPI  R30,LOW(0x6F)
	BRNE _0xE7
;     928 if(packet[TCP_data+5]=='f')
	__GETB1MN _packet,59
	CPI  R30,LOW(0x66)
	BRNE _0xE8
;     929 if(packet[TCP_data+6]=='f')
	__GETB1MN _packet,60
	CPI  R30,LOW(0x66)
	BRNE _0xE9
;     930 if(packet[TCP_data+7]==' ')
	__GETB1MN _packet,61
	CPI  R30,LOW(0x20)
	BRNE _0xEA
;     931 if(packet[TCP_data+8]=='a')
	__GETB1MN _packet,62
	CPI  R30,LOW(0x61)
	BRNE _0xEB
;     932 if(packet[TCP_data+9]=='l')
	__GETB1MN _packet,63
	CPI  R30,LOW(0x6C)
	BRNE _0xEC
;     933 if(packet[TCP_data+10]=='a')
	__GETB1MN _packet,64
	CPI  R30,LOW(0x61)
	BRNE _0xED
;     934 if(packet[TCP_data+11]=='r')
	__GETB1MN _packet,65
	CPI  R30,LOW(0x72)
	BRNE _0xEE
;     935 if(packet[TCP_data+12]=='m')
	__GETB1MN _packet,66
	CPI  R30,LOW(0x6D)
	BRNE _0xEF
;     936 
;     937     {
;     938     for(i=0;i<8;i++)
	__GETWRN 20,21,0
_0xF1:
	__CPWRN 20,21,8
	BRGE _0xF2
;     939     {
;     940     packet[TCP_data+i]=ack3[i];
	CALL SUBOPT_0x27
	MOVW R26,R28
	ADIW R26,21
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
;     941     }
	__ADDWRN 20,21,1
	RJMP _0xF1
_0xF2:
;     942     transmit(TCP,Sock0,8,packet);
	CALL SUBOPT_0x1E
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL SUBOPT_0x26
	RCALL _transmit
;     943     stage++;
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
;     944     goto Listen;
	RJMP _0x7B
;     945     }
;     946 
;     947 if(Authentication)                          //Get how long the alrarm would be turned off
_0xEF:
_0xEE:
_0xED:
_0xEC:
_0xEB:
_0xEA:
_0xE9:
_0xE8:
_0xE7:
_0xE6:
_0xE5:
_0xE4:
_0xE3:
_0xE2:
_0xE1:
	LDD  R30,Y+40
	CPI  R30,0
	BREQ _0xF3
;     948 if(stage==2)
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BRNE _0xF4
;     949 {
;     950 minutes= packet[TCP_data];
	__GETB1MN _packet,54
	__PUTB1SX 88
;     951 for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xF6:
	__CPWRN 20,21,2
	BRGE _0xF7
;     952 {
;     953 packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     954 }
	__ADDWRN 20,21,1
	RJMP _0xF6
_0xF7:
;     955 transmit(TCP,Sock0,2,packet);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     956 stage=1;
	LDI  R30,LOW(1)
	STD  Y+4,R30
;     957 goto Listen;                        //wait further commands
	RJMP _0x7B
;     958 }
;     959 
;     960 if(Authentication)                   //Start executing Commands
_0xF4:
_0xF3:
	LDD  R30,Y+40
	CPI  R30,0
	BREQ _0xF8
;     961 if(stage==1)
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRNE _0xF9
;     962 if(packet[TCP_data]=='e')         //Last command "exit"
	__GETB1MN _packet,54
	CPI  R30,LOW(0x65)
	BRNE _0xFA
;     963 if(packet[TCP_data+1]=='x')         //response is "OK"
	__GETB1MN _packet,55
	CPI  R30,LOW(0x78)
	BRNE _0xFB
;     964 if(packet[TCP_data+2]=='i')
	__GETB1MN _packet,56
	CPI  R30,LOW(0x69)
	BRNE _0xFC
;     965 if(packet[TCP_data+3]=='t')
	__GETB1MN _packet,57
	CPI  R30,LOW(0x74)
	BRNE _0xFD
;     966     {
;     967     for(i=0;i<2;i++)
	__GETWRN 20,21,0
_0xFF:
	__CPWRN 20,21,2
	BRGE _0x100
;     968     {
;     969     packet[TCP_data+i]=ack1[i];
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
;     970     }
	__ADDWRN 20,21,1
	RJMP _0xFF
_0x100:
;     971     transmit(TCP,Sock0,2,packet);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x29
	RCALL _transmit
;     972     Authentication=0;
	LDI  R30,LOW(0)
	STD  Y+40,R30
;     973     stage=0;
	STD  Y+4,R30
;     974     goto Listen;
	RJMP _0x7B
;     975     }
;     976 
;     977 
;     978 
;     979 /*****************************************************
;     980 Client ,Alarm Activated , Motion Sensed
;     981 *****************************************************/
;     982 
;     983 
;     984      }    //end while data recieved
_0xFD:
_0xFC:
_0xFB:
_0xFA:
_0xF9:
_0xF8:
	RJMP _0x84
_0x86:
;     985 
;     986 
;     987     else  //mode=1                          //if client
	RJMP _0x101
_0x83:
;     988 
;     989      {
;     990      send_alarm:
_0x82:
;     991      if(!count2)                           //Set first alert time
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0x102
;     992         {
;     993         rtc_get_date(&d_temp,&mm_temp,&y_temp);
	MOVW R30,R28
	SUBI R30,LOW(-(84))
	SBCI R31,HIGH(-(84))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(85))
	SBCI R31,HIGH(-(85))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(86))
	SBCI R31,HIGH(-(86))
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_date
;     994 	    rtc_get_time(&h_temp,&m_temp,&s_temp);
	MOVW R30,R28
	SUBI R30,LOW(-(87))
	SBCI R31,HIGH(-(87))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(88))
	SBCI R31,HIGH(-(88))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(89))
	SBCI R31,HIGH(-(89))
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_time
;     995 	    count2=1;
	LDI  R30,LOW(1)
	STD  Y+6,R30
;     996         }
;     997 
;     998         rtc_get_date(&d,&mm,&y);
_0x102:
	CALL SUBOPT_0x21
;     999 	    rtc_get_time(&h,&m,&s);
;    1000 
;    1001         if(h==h_temp && m<(m_temp+5))           //keep alarm for only 5 minutes if human motion is still sensed
	BRNE _0x104
	__GETB1SX 86
	SUBI R30,-LOW(5)
	CALL SUBOPT_0x22
	CP   R26,R30
	BRLO _0x105
_0x104:
	RJMP _0x103
_0x105:
;    1002 
;    1003 	    for(i=0;i<13;i++)
	__GETWRN 20,21,0
_0x107:
	__CPWRN 20,21,13
	BRGE _0x108
;    1004         {
;    1005         packet[TCP_data+i]=alarm1[i];
	CALL SUBOPT_0x27
	MOVW R26,R28
	ADIW R26,8
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
;    1006         }
	__ADDWRN 20,21,1
	RJMP _0x107
_0x108:
;    1007         packet[TCP_data+i]=' ';
_0x103:
	MOVW R30,R20
	__ADDW1MN _packet,54
	LDI  R26,LOW(32)
	STD  Z+0,R26
;    1008         packet[TCP_data+i+1]='i';
	MOVW R30,R20
	__ADDW1MN _packet,55
	LDI  R26,LOW(105)
	STD  Z+0,R26
;    1009         packet[TCP_data+i+2]='n';
	MOVW R30,R20
	__ADDW1MN _packet,56
	LDI  R26,LOW(110)
	CALL SUBOPT_0x2B
;    1010         packet[TCP_data+i+8]=' ';
;    1011         packet[TCP_data+i+3]=d;
	__ADDW1MN _packet,57
	__GETB2SX 91
	STD  Z+0,R26
;    1012         packet[TCP_data+i+4]='/';
	MOVW R30,R20
	__ADDW1MN _packet,58
	LDI  R26,LOW(47)
	STD  Z+0,R26
;    1013         packet[TCP_data+i+5]=mm;
	MOVW R30,R20
	__ADDW1MN _packet,59
	__GETB2SX 90
	STD  Z+0,R26
;    1014         packet[TCP_data+i+6]='/';
	MOVW R30,R20
	__ADDW1MN _packet,60
	LDI  R26,LOW(47)
	STD  Z+0,R26
;    1015         packet[TCP_data+i+7]=y;
	MOVW R30,R20
	__ADDW1MN _packet,61
	__GETB2SX 89
	CALL SUBOPT_0x2B
;    1016         packet[TCP_data+i+8]=' ';
;    1017         packet[TCP_data+i+9]='a';
	__ADDW1MN _packet,63
	LDI  R26,LOW(97)
	STD  Z+0,R26
;    1018         packet[TCP_data+i+10]='t';
	MOVW R30,R20
	__ADDW1MN _packet,64
	LDI  R26,LOW(116)
	STD  Z+0,R26
;    1019         packet[TCP_data+i+11]=' ';
	MOVW R30,R20
	__ADDW1MN _packet,65
	LDI  R26,LOW(32)
	STD  Z+0,R26
;    1020         packet[TCP_data+i+12]=h;
	MOVW R30,R20
	__ADDW1MN _packet,66
	__GETB2SX 94
	STD  Z+0,R26
;    1021         packet[TCP_data+i+13]=':';
	MOVW R30,R20
	__ADDW1MN _packet,67
	LDI  R26,LOW(58)
	STD  Z+0,R26
;    1022         packet[TCP_data+i+14]=m;
	MOVW R30,R20
	__ADDW1MN _packet,68
	CALL SUBOPT_0x22
	STD  Z+0,R26
;    1023         packet[TCP_data+i+15]=':';
	MOVW R30,R20
	__ADDW1MN _packet,69
	LDI  R26,LOW(58)
	STD  Z+0,R26
;    1024         packet[TCP_data+i+16]=s;
	MOVW R30,R20
	__ADDW1MN _packet,70
	__GETB2SX 92
	STD  Z+0,R26
;    1025 
;    1026         transmit(TCP,Sock0,31,packet);
	CALL SUBOPT_0x1E
	LDI  R30,LOW(31)
	ST   -Y,R30
	CALL SUBOPT_0x26
	RCALL _transmit
;    1027         goto Listen;
	RJMP _0x7B
;    1028 
;    1029      }    //end else if alarm
_0x101:
;    1030 
;    1031      }     //end while SOCK_ESTABLISHED
	RJMP _0x78
_0x7A:
;    1032 
;    1033 
;    1034     exit: check_disconnect(TCP,Sock0);
_0x8B:
	CALL SUBOPT_0x1E
	RCALL _check_disconnect
;    1035 
;    1036 };
	RJMP _0x6D
;    1037 
;    1038 
;    1039 
;    1040 
;    1041 }
_0x109:
	RJMP _0x109
;    1042 
;    1043 /*****************************************************
;    1044 Initialization
;    1045 *****************************************************/
;    1046 void initialize()
;    1047 {
_initialize:
;    1048   volatile unsigned char IOReg;
;    1049 // USART initialization
;    1050 // Communication Parameters: 8 Data, 1 Stop, No Parity
;    1051 // USART Receiver: On
;    1052 // USART Transmitter: On
;    1053 // USART Mode: Asynchronous
;    1054 // USART Baud Rate: 115200
;    1055 UCSRA=0x00;
	SBIW R28,1
;	IOReg -> Y+0
	LDI  R30,LOW(0)
	OUT  0xB,R30
;    1056 UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;    1057 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;    1058 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;    1059 UBRRL=0x03;
	LDI  R30,LOW(3)
	OUT  0x9,R30
;    1060 
;    1061 
;    1062 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;    1063 DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;    1064 
;    1065 DDRD.4=1;//Lights Relay
	SBI  0x11,4
;    1066 DDRD.2=0;//PIR
	CBI  0x11,2
;    1067 
;    1068 DDRC=0xF0;
	LDI  R30,LOW(240)
	OUT  0x14,R30
;    1069 PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
;    1070 
;    1071 //   Configure I/O pins
;    1072   DDRB = (1<<MOSI) | (1<<SCK) | (1<<SLAVE_SELECT);//OUTPUT
	LDI  R30,LOW(176)
	OUT  0x17,R30
;    1073   DDRB &=~(1<<MISO);                                             //INPUT
	CBI  0x17,6
;    1074 
;    1075   PORTB |=  (1<<SLAVE_SELECT) ;       // Disable slave
	SBI  0x18,4
;    1076 //SPI
;    1077   SPCR = (1<<SPE)| (1<<MSTR);  //SPI Enable     //Master mode
	LDI  R30,LOW(80)
	OUT  0xD,R30
;    1078   IOReg   = SPSR;
	IN   R30,0xE
	ST   Y,R30
;    1079   IOReg   = SPDR;
	IN   R30,0xF
	ST   Y,R30
;    1080   delay_ms(10);
	CALL SUBOPT_0x2C
;    1081 //   Configure I/O pins
;    1082   DDRB  |=  (1<<PIN_RESET) ; // OUTPUT to control the wiznet reset
	SBI  0x17,0
;    1083   PORTB |=  (1<<PIN_RESET) ; // no reset
	SBI  0x18,0
;    1084   delay_ms(10);
	CALL SUBOPT_0x2C
;    1085   PORTB &= ~(1<<PIN_RESET) ; //reset the module
	CBI  0x18,0
;    1086   delay_ms(10);
	CALL SUBOPT_0x2C
;    1087   PORTB |=  (1<<PIN_RESET) ;
	SBI  0x18,0
;    1088   delay_ms(10);
	CALL SUBOPT_0x2C
;    1089 }
	RJMP _0x221
;    1090 
;    1091 /*****************************************************
;    1092 Set Initial IP registers
;    1093 *****************************************************/
;    1094 
;    1095 void setGAR(unsigned char *addr)
;    1096 {
_setGAR:
;    1097   // default gateway
;    1098   wiz_wr((GAR0 + 0),addr[0]);
;	*addr -> Y+0
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2E
;    1099   wiz_wr((GAR0 + 1),addr[1]);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x30
;    1100   wiz_wr((GAR0 + 2),addr[2]);
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x31
;    1101   wiz_wr((GAR0 + 3),addr[3]);
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x32
;    1102 }
	RJMP _0x21E
;    1103 
;    1104 void setSUBR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the SubnetMask address */
;    1105 {
_setSUBR:
;    1106 	wiz_wr((SUBR0 + 0),addr[0]);
;	*addr -> Y+0
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0x33
;    1107 	wiz_wr((SUBR0 + 1),addr[1]);
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x30
;    1108 	wiz_wr((SUBR0 + 2),addr[2]);
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x31
;    1109 	wiz_wr((SUBR0 + 3),addr[3]);
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x32
;    1110 }
	RJMP _0x21E
;    1111 
;    1112 void setSHAR(unsigned char * addr)	/**< a pointer to a 6 -byte array responsible to set the MAC address. */
;    1113 {
_setSHAR:
;    1114 	wiz_wr((SHAR0 + 0),addr[0]);
;	*addr -> Y+0
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	CALL SUBOPT_0x33
;    1115 	wiz_wr((SHAR0 + 1),addr[1]);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x30
;    1116 	wiz_wr((SHAR0 + 2),addr[2]);
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x31
;    1117 	wiz_wr((SHAR0 + 3),addr[3]);
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x32
;    1118 	wiz_wr((SHAR0 + 4),addr[4]);
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	CALL SUBOPT_0x2F
	ADIW R26,4
	CALL SUBOPT_0x34
;    1119 	wiz_wr((SHAR0 + 5),addr[5]);
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	CALL SUBOPT_0x2F
	ADIW R26,5
	CALL SUBOPT_0x34
;    1120 }
	RJMP _0x21E
;    1121 
;    1122 void setSIPR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the Source IP address. */
;    1123 {
_setSIPR:
;    1124 	wiz_wr((SIPR0 + 0),addr[0]);
;	*addr -> Y+0
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL SUBOPT_0x33
;    1125 	wiz_wr((SIPR0 + 1),addr[1]);
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x30
;    1126 	wiz_wr((SIPR0 + 2),addr[2]);
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x31
;    1127 	wiz_wr((SIPR0 + 3),addr[3]);
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x32
;    1128 }
	RJMP _0x21E
;    1129 /*****************************************************
;    1130 Reading and Writing Wiznet Registers
;    1131 *****************************************************/
;    1132 unsigned char wiz_rd(unsigned int address)
;    1133 {
_wiz_rd:
;    1134  unsigned char data = 0x00;
;    1135 
;    1136  PORTB &= ~(1<<SLAVE_SELECT) ; //enable slave
	ST   -Y,R17
;	address -> Y+1
;	data -> R17
	LDI  R17,0
	CBI  0x18,4
;    1137 
;    1138  spi_transfer(WIZNET_OPCODE_READ);
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL _spi_transfer
;    1139  spi_transfer((address>>8) & 0x00FF);
	LDD  R30,Y+2
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _spi_transfer
;    1140  spi_transfer(address& 0x00FF);
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _spi_transfer
;    1141  data = spi_transfer(DUMMY_DATA);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_transfer
	MOV  R17,R30
;    1142 
;    1143  PORTB |=  (1<<SLAVE_SELECT) ;       // Disable slave
	SBI  0x18,4
;    1144 
;    1145   return data;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,3
	RET
;    1146 }
;    1147 
;    1148 void wiz_wr(unsigned int address, unsigned int targetValue)
;    1149 {
_wiz_wr:
;    1150 
;    1151  PORTB &= ~(1<<SLAVE_SELECT) ; //enable slave
;	address -> Y+2
;	targetValue -> Y+0
	CBI  0x18,4
;    1152 
;    1153  spi_transfer(WIZNET_OPCODE_WRITE);
	LDI  R30,LOW(240)
	ST   -Y,R30
	RCALL _spi_transfer
;    1154  spi_transfer((address>>8) & 0x00FF);
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _spi_transfer
;    1155  spi_transfer(address & 0x00FF);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ANDI R31,HIGH(0xFF)
	ST   -Y,R30
	RCALL _spi_transfer
;    1156  spi_transfer(targetValue);
	LD   R30,Y
	ST   -Y,R30
	RCALL _spi_transfer
;    1157 
;    1158  PORTB |=  (1<<SLAVE_SELECT) ;  // Disable slave
	SBI  0x18,4
;    1159 }
	RJMP _0x220
;    1160 
;    1161 
;    1162 
;    1163 /*****************************************************
;    1164 SPI
;    1165 *****************************************************/
;    1166 unsigned char spi_transfer(volatile unsigned char data)
;    1167 {
_spi_transfer:
;    1168   SPDR = data;                    // Start the transmission
;	data -> Y+0
	LD   R30,Y
	OUT  0xF,R30
;    1169   while (!(SPSR & (1<<SPIF)));     // Wait for the end of the transmission
_0x10A:
	SBIS 0xE,7
	RJMP _0x10A
;    1170   return SPDR;                    // return the received byte
	IN   R30,0xF
_0x221:
	ADIW R28,1
	RET
;    1171 }
;    1172  /*****************************************************
;    1173 Listening and Connecting
;    1174 *****************************************************/
;    1175 
;    1176 
;    1177 unsigned char Listen_TCP(unsigned char socket_no)
;    1178 {
_Listen_TCP:
;    1179 unsigned char ret;
;    1180 	if (wiz_rd(Sn_SR(socket_no)) == SOCK_INIT)
	CALL SUBOPT_0x35
;	socket_no -> Y+1
;	ret -> R17
	BRNE _0x10D
;    1181 	{
;    1182 		wiz_wr(Sn_CR(socket_no),Sn_CR_LISTEN);
	CALL SUBOPT_0x36
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	CALL _wiz_wr
;    1183 		ret = 1;
	LDI  R17,LOW(1)
;    1184 	}
;    1185 	else
	RJMP _0x10E
_0x10D:
;    1186 	{
;    1187 		ret = 0;
	LDI  R17,LOW(0)
;    1188 	}
_0x10E:
;    1189 return ret;
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x21E
;    1190 }
;    1191 unsigned char Connect_TCP(unsigned char socket_no)
;    1192 {
_Connect_TCP:
;    1193 unsigned char ret;
;    1194 	if (wiz_rd(Sn_SR(socket_no)) == SOCK_INIT)
	CALL SUBOPT_0x35
;	socket_no -> Y+1
;	ret -> R17
	BRNE _0x10F
;    1195 	{
;    1196 		wiz_wr(Sn_CR(socket_no),Sn_CR_CONNECT);
	CALL SUBOPT_0x36
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x37
;    1197 		ret = 1;
	LDI  R17,LOW(1)
;    1198 	}
;    1199 	else
	RJMP _0x110
_0x10F:
;    1200 	{
;    1201 		ret = 0;
	LDI  R17,LOW(0)
;    1202 	}
_0x110:
;    1203 return ret;
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x21E
;    1204 }
;    1205 
;    1206  /*****************************************************
;    1207 Sockets
;    1208 *****************************************************/
;    1209 
;    1210 void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no)
;    1211  {
_open_socket:
;    1212     if(socket_type==TCP)
;	socket_type -> Y+3
;	socket_no -> Y+2
;	port_no -> Y+0
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRNE _0x111
;    1213 	  {
;    1214 	  do{
_0x113:
;    1215 	  wiz_wr(Sn_MR(socket_no),Sn_MR_TCP);				//protocol = TDP
	LDD  R31,Y+2
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1024)
	SBCI R31,HIGH(-1024)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x2D
	CALL _wiz_wr
;    1216 	  wiz_wr(Sn_PORT0(socket_no),(port_no>>8) & 0x00FF);				//well-know ECHO port
	LDD  R31,Y+2
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1028)
	SBCI R31,HIGH(-1028)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x37
;    1217 	  wiz_wr(Sn_PORT1(socket_no),port_no & 0x00FF);        //set source port
	LDD  R31,Y+2
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1029)
	SBCI R31,HIGH(-1029)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x37
;    1218 	  wiz_wr(Sn_CR(socket_no),Sn_CR_OPEN);			//give the open command
	CALL SUBOPT_0x38
	CALL SUBOPT_0x2D
	CALL _wiz_wr
;    1219 	  if(wiz_rd(Sn_SR(socket_no)) != SOCK_INIT)		//wait for the socket to come online
	CALL SUBOPT_0x39
	BREQ _0x115
;    1220 		  wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);    //close socket if not open correctly
	CALL SUBOPT_0x38
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL SUBOPT_0x37
;    1221 		}
_0x115:
;    1222 	  while(wiz_rd(Sn_SR(socket_no)) != SOCK_INIT);
	CALL SUBOPT_0x39
	BRNE _0x113
;    1223 	  }
;    1224  }
_0x111:
_0x220:
	ADIW R28,4
	RET
;    1225 
;    1226 unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no)
;    1227 {
_get_sock_size:
;    1228 unsigned int hi_byte,lo_byte,get_size;
;    1229   if(socket_type==TCP)
	CALL SUBOPT_0x3A
;	socket_type -> Y+7
;	socket_no -> Y+6
;	hi_byte -> R16,R17
;	lo_byte -> R18,R19
;	get_size -> R20,R21
	BRNE _0x116
;    1230   {
;    1231    hi_byte = wiz_rd(Sn_RX_RSR0(socket_no));              //get size of the packet in the "recieve size" register  RSR
	LDD  R31,Y+6
	LDI  R30,LOW(0)
	CALL SUBOPT_0x24
	CALL SUBOPT_0x3B
;    1232 	lo_byte = wiz_rd(Sn_RX_RSR1(socket_no));
	CALL SUBOPT_0x25
	CALL SUBOPT_0x3C
;    1233 	get_size = make16(hi_byte,lo_byte);                     //make a 16 bit size
	ADD  R30,R26
	ADC  R31,R27
	MOVW R20,R30
;    1234 	return get_size;
	MOVW R30,R20
	RJMP _0x21F
;    1235   }
;    1236 }
_0x116:
	RJMP _0x21F
;    1237 
;    1238 unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no)
;    1239 {
_get_WR_offset:
;    1240 unsigned int hi_byte,lo_byte,get_offset;
;    1241   if(socket_type==TCP)
	CALL SUBOPT_0x3A
;	socket_type -> Y+7
;	socket_no -> Y+6
;	hi_byte -> R16,R17
;	lo_byte -> R18,R19
;	get_offset -> R20,R21
	BRNE _0x117
;    1242   {
;    1243   hi_byte = wiz_rd(Sn_TX_WR0(socket_no));           //Read the TX Write Pointer Register
	LDD  R31,Y+6
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1060)
	SBCI R31,HIGH(-1060)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3B
;    1244 	lo_byte = wiz_rd(Sn_TX_WR1(socket_no));
	SUBI R30,LOW(-1061)
	SBCI R31,HIGH(-1061)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3C
;    1245 	get_offset = make16(hi_byte,lo_byte) & gS0_TX_MASK; // first 11 bits required of the offset
	CALL SUBOPT_0x3E
;    1246 	return get_offset;
	RJMP _0x21F
;    1247   }
;    1248 }
_0x117:
	RJMP _0x21F
;    1249 
;    1250 unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no)
;    1251 {
_get_RD_offset:
;    1252 unsigned int hi_byte,lo_byte,get_offset;
;    1253   if(socket_type==TCP)
	CALL SUBOPT_0x3A
;	socket_type -> Y+7
;	socket_no -> Y+6
;	hi_byte -> R16,R17
;	lo_byte -> R18,R19
;	get_offset -> R20,R21
	BRNE _0x118
;    1254   {
;    1255 	hi_byte = wiz_rd(Sn_RX_RD0(socket_no));               // read the "RX read pointer" register value
	LDD  R31,Y+6
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1064)
	SBCI R31,HIGH(-1064)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3B
;    1256 	lo_byte = wiz_rd(Sn_RX_RD1(socket_no));
	SUBI R30,LOW(-1065)
	SBCI R31,HIGH(-1065)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3C
;    1257 	get_offset = make16(hi_byte,lo_byte) & gS0_RX_MASK;     // first 11 bits required of the offset
	CALL SUBOPT_0x3E
;    1258 	return get_offset;
	RJMP _0x21F
;    1259   }
;    1260 }
_0x118:
	RJMP _0x21F
;    1261 
;    1262 unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no)
;    1263 {
_check_TX_buffer:
;    1264 unsigned int hi_byte,lo_byte,get_free_size;
;    1265   if(socket_type==TCP)
	CALL SUBOPT_0x3A
;	socket_type -> Y+7
;	socket_no -> Y+6
;	hi_byte -> R16,R17
;	lo_byte -> R18,R19
;	get_free_size -> R20,R21
	BRNE _0x119
;    1266   {
;    1267     hi_byte = wiz_rd(Sn_TX_FSR0(socket_no));          // Read Transmitter free size register
	LDD  R31,Y+6
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1056)
	SBCI R31,HIGH(-1056)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3B
;    1268 	  lo_byte = wiz_rd(Sn_TX_FSR1(socket_no));
	SUBI R30,LOW(-1057)
	SBCI R31,HIGH(-1057)
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3C
;    1269 	  get_free_size = make16(hi_byte,lo_byte);            //Get the TX Buffer Free size
	ADD  R30,R26
	ADC  R31,R27
	MOVW R20,R30
;    1270 	  return get_free_size;
	MOVW R30,R20
;    1271 
;    1272   }
;    1273 }
_0x119:
_0x21F:
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;    1274 
;    1275 void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address )
;    1276 {
_wr_dst_addr_TCP:
;    1277 unsigned int addri;
;    1278 int i8;
;    1279          addri = Sn_DIPR0(socket_no);                                //Get the address of the "destination IP address register"
	CALL __SAVELOCR4
;	socket_no -> Y+8
;	*config_dst_ip_address -> Y+6
;	*config_dst_port_address -> Y+4
;	addri -> R16,R17
;	i8 -> R18,R19
	LDD  R31,Y+8
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1036)
	SBCI R31,HIGH(-1036)
	MOVW R16,R30
;    1280 	      for(i8=0;i8<4;++i8)
	__GETWRN 18,19,0
_0x11B:
	__CPWRN 18,19,4
	BRGE _0x11C
;    1281 		   wiz_wr(addri++,config_dst_ip_address[i8]);//Write the destination IP address to send
	CALL SUBOPT_0x3F
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL SUBOPT_0x18
	CALL SUBOPT_0x37
;    1282 	      addri = Sn_DPORT0(socket_no);                               //Get the address of the "destination PORT address register"
	__ADDWRN 18,19,1
	RJMP _0x11B
_0x11C:
	LDD  R31,Y+8
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1040)
	SBCI R31,HIGH(-1040)
	MOVW R16,R30
;    1283 	      for(i8=0;i8<2;++i8)
	__GETWRN 18,19,0
_0x11E:
	__CPWRN 18,19,2
	BRGE _0x11F
;    1284 		      wiz_wr(addri++,config_dst_port_address[i8]);//Write the destination PORT address to send
	CALL SUBOPT_0x3F
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL SUBOPT_0x18
	CALL SUBOPT_0x37
;    1285 }
	__ADDWRN 18,19,1
	RJMP _0x11E
_0x11F:
	CALL __LOADLOCR4
	ADIW R28,9
	RET
;    1286 
;    1287 /*****************************************************
;    1288 Disconnecting
;    1289 *****************************************************/
;    1290 
;    1291 void sock_close(unsigned char socket_type,unsigned char socket_no)
;    1292 {
;    1293    if(socket_type==TCP)
;	socket_type -> Y+1
;	socket_no -> Y+0
;    1294       {
;    1295       wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);        //close socket
;    1296       }
;    1297 }
;    1298 
;    1299 void check_disconnect(unsigned char socket_type,unsigned char socket_no)
;    1300 {
_check_disconnect:
;    1301  if(socket_type==TCP)
;	socket_type -> Y+1
;	socket_no -> Y+0
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BRNE _0x121
;    1302    {
;    1303         if(wiz_rd(Sn_SR(socket_no)) == SOCK_CLOSE_WAIT || wiz_rd(Sn_SR(socket_no))==SOCK_CLOSED ||wiz_rd(Sn_IR(socket_no))&0x0A )
	CALL SUBOPT_0x40
	CPI  R30,LOW(0x1C)
	BREQ _0x123
	CALL SUBOPT_0x40
	CPI  R30,0
	BREQ _0x123
	CALL SUBOPT_0x41
	ANDI R30,LOW(0xA)
	BREQ _0x122
_0x123:
;    1304 		   {
;    1305 		   wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);        //close socket
	LD   R31,Y
	CALL SUBOPT_0x42
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL SUBOPT_0x37
;    1306 		   open_socket(TCP,socket_no,source_port_number);      //open a TCP socket
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	ST   -Y,R5
	ST   -Y,R4
	CALL _open_socket
;    1307 		   if(wiz_rd(Sn_IR(socket_no))&0x0A)
	CALL SUBOPT_0x41
	ANDI R30,LOW(0xA)
	BREQ _0x125
;    1308 		   wiz_wr(Sn_IR(socket_no),0x0A);//clear registers
	LD   R31,Y
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1026)
	SBCI R31,HIGH(-1026)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x37
;    1309 		   printf("&");
_0x125:
	__POINTW1FN _0,259
	CALL SUBOPT_0x43
;    1310 		   }
;    1311    }
_0x122:
;    1312 }
_0x121:
_0x21E:
	ADIW R28,2
	RET
;    1313 
;    1314 void disconnect(unsigned char socket_type,unsigned char socket_no)
;    1315 {
;    1316    if(socket_type==TCP)
;	socket_type -> Y+1
;	socket_no -> Y+0
;    1317       wiz_wr(Sn_CR(socket_no),Sn_CR_DISCON);        //close socket
;    1318 }
;    1319 
;    1320 /*****************************************************
;    1321 Transmission and Reception
;    1322 *****************************************************/
;    1323 
;    1324 void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet)
;    1325 {
_transmit:
;    1326 
;    1327 unsigned int get_offset,get_start_address;
;    1328 unsigned int get_free_size;
;    1329 int i8;
;    1330 unsigned int addri;
;    1331 
;    1332       // first, get the free TX memory size
;    1333       do
	SBIW R28,4
	CALL __SAVELOCR6
;	socket_type -> Y+14
;	socket_no -> Y+13
;	get_size -> Y+12
;	*packet -> Y+10
;	get_offset -> R16,R17
;	get_start_address -> R18,R19
;	get_free_size -> R20,R21
;	i8 -> Y+8
;	addri -> Y+6
_0x128:
;    1334       {
;    1335          get_free_size=check_TX_buffer(TCP,Sock0);           //Get the TX Buffer Free size
	CALL SUBOPT_0x1E
	CALL _check_TX_buffer
	MOVW R20,R30
;    1336       }
;    1337       while(get_free_size < get_size);
	LDD  R30,Y+12
	MOVW R26,R20
	CALL SUBOPT_0x44
	BRLO _0x128
;    1338 
;    1339       get_offset=get_WR_offset(TCP,Sock0);                //Get the write offset
	CALL SUBOPT_0x1E
	CALL _get_WR_offset
	MOVW R16,R30
;    1340 
;    1341 	   get_start_address = gS0_TX_BASE + get_offset;       //Get beginning address where the UDP data are stored
	MOVW R30,R16
	SUBI R30,LOW(-16384)
	SBCI R31,HIGH(-16384)
	MOVW R18,R30
;    1342 	   addri = get_start_address;
	__PUTWSR 18,19,6
;    1343 
;    1344 //No need for more than 2 KBs in our application
;    1345 /*
;    1346 	   if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
;    1347          {
;    1348            //store UDP header
;    1349 
;    1350            // copy upper_size bytes of get_start_address to destination_addr
;    1351            upper_size = (gS0_RX_MASK + 1) - get_offset ;
;    1352 	          for(i8=0;i8<upper_size;++i8)
;    1353 	            {
;    1354 		          		wiz_wr(addri++,packet[TCP_data+i8]);
;    1355 		               ++get_offset;
;    1356 	            }
;    1357             // copy left_size bytes of gSn_RX_BASE to destination_addr
;    1358             left_size = get_size - upper_size;
;    1359 
;    1360 	         for(i8=0;i8<left_size;++i8)
;    1361 	          {
;    1362 		         wiz_wr(gS0_TX_BASE+i8,packet[TCP_data + upper_size+i8]);
;    1363 	          }
;    1364 
;    1365 
;    1366          }//end if
;    1367       else
;    1368  */
;    1369 	   for(i8=0;i8<get_size;++i8)                     //Write the UDP data to the TX buffer
	LDI  R30,0
	STD  Y+8,R30
	STD  Y+8+1,R30
_0x12B:
	LDD  R30,Y+12
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL SUBOPT_0x44
	BRGE _0x12C
;    1370 	   {
;    1371 		   wiz_wr(addri++,packet[TCP_data+i8]);
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	CALL SUBOPT_0x18
	CALL SUBOPT_0x37
;    1372 		   ++get_offset;
	__ADDWRN 16,17,1
;    1373 		   printf("-%c-",packet[TCP_data+i8]);
	__POINTW1FN _0,261
	CALL SUBOPT_0x46
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x47
;    1374 	   }
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RJMP _0x12B
_0x12C:
;    1375 	   wiz_wr(Sn_TX_WR0(socket_no),(make8(get_offset,1)));
	LDD  R31,Y+13
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1060)
	SBCI R31,HIGH(-1060)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x37
;    1376 	   wiz_wr(Sn_TX_WR1(socket_no),(make8(get_offset,0)));
	LDD  R31,Y+13
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1061)
	SBCI R31,HIGH(-1061)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x37
;    1377 	   wiz_wr(Sn_CR(socket_no),Sn_CR_SEND);             //Send data
	LDD  R31,Y+13
	CALL SUBOPT_0x42
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CALL SUBOPT_0x37
;    1378 	   while(wiz_rd(Sn_CR(socket_no)));                  //wait for the data to be transmitted
_0x12D:
	LDD  R31,Y+13
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1025)
	SBCI R31,HIGH(-1025)
	CALL SUBOPT_0x3D
	CPI  R30,0
	BRNE _0x12D
;    1379 
;    1380 }
	CALL __LOADLOCR6
	ADIW R28,15
	RET
;    1381 
;    1382 unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet)
;    1383 {
_recieve:
;    1384 
;    1385 unsigned int get_size, get_offset,get_start_address;
;    1386 int i8;
;    1387 unsigned int addri;
;    1388       get_size=get_sock_size(TCP,Sock0);                      //get the socket size
	SBIW R28,4
	CALL __SAVELOCR6
;	socket_type -> Y+13
;	socket_no -> Y+12
;	*packet -> Y+10
;	get_size -> R16,R17
;	get_offset -> R18,R19
;	get_start_address -> R20,R21
;	i8 -> Y+8
;	addri -> Y+6
	CALL SUBOPT_0x1E
	CALL _get_sock_size
	MOVW R16,R30
;    1389       if(get_size==2048)                                      //at very rare situations this happens ,,it killed me
	LDI  R30,LOW(2048)
	LDI  R31,HIGH(2048)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x130
;    1390         {
;    1391             wiz_wr(Sn_CR(socket_no),Sn_CR_DISCON);
	LDD  R31,Y+12
	CALL SUBOPT_0x42
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL SUBOPT_0x37
;    1392             return 0;
	LDI  R30,LOW(0)
	RJMP _0x21D
;    1393         }
;    1394 	 printf("-3-");
_0x130:
	__POINTW1FN _0,266
	CALL SUBOPT_0x43
;    1395 	   get_offset=get_RD_offset(TCP,socket_no);                  //get the read offset
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDD  R30,Y+13
	ST   -Y,R30
	CALL _get_RD_offset
	MOVW R18,R30
;    1396 	   get_start_address = gS0_RX_BASE + get_offset;           //Get beginning address of the UDP packets header
	MOVW R30,R18
	SUBI R30,LOW(-24576)
	SBCI R31,HIGH(-24576)
	MOVW R20,R30
;    1397         printf("-4-");
	__POINTW1FN _0,270
	CALL SUBOPT_0x43
;    1398       addri = get_start_address;
	__PUTWSR 20,21,6
;    1399 
;    1400 //No need for more than 2 KBs in our application
;    1401 
;    1402 /*    // if overflow socket RX memory
;    1403       if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
;    1404       {
;    1405         printf("-*-"); printf("+%d+",get_size);
;    1406             //store UDP header
;    1407 
;    1408             // copy upper_size bytes of get_start_address to destination_addr
;    1409             upper_size = (gS0_RX_MASK + 1) - get_offset ;
;    1410 	            for(i8=0;i8<upper_size;++i8)
;    1411 	            {
;    1412 		            packet[TCP_data+i8] = wiz_rd(addri++);
;    1413 	            }
;    1414                // copy left_size bytes of gSn_RX_BASE to destination_addr
;    1415                left_size = get_size - upper_size;
;    1416 
;    1417 	            for(i8=0;i8<left_size;++i8)
;    1418 	               {
;    1419 		            packet[TCP_data + upper_size+i8] = wiz_rd(gS0_TX_BASE+i8);
;    1420 	               }
;    1421 
;    1422 
;    1423        }//end if
;    1424 
;    1425 
;    1426       //else      */
;    1427 
;    1428 // copy get_size bytes of get_start_address to destination_addr
;    1429 	         for(i8=0;i8<get_size;++i8)
	LDI  R30,0
	STD  Y+8,R30
	STD  Y+8+1,R30
_0x132:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CP   R26,R16
	CPC  R27,R17
	BRSH _0x133
;    1430 	            {
;    1431 		            packet[TCP_data+i8] = wiz_rd(addri++);
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,54
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x45
	CALL SUBOPT_0x3D
	POP  R26
	POP  R27
	ST   X,R30
;    1432 		            ++get_offset;
	__ADDWRN 18,19,1
;    1433 		            printf("-%d-",i8);
	__POINTW1FN _0,274
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __CWD1
	CALL SUBOPT_0x47
;    1434 	            }
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RJMP _0x132
_0x133:
;    1435 	         printf("-6-");
	__POINTW1FN _0,279
	CALL SUBOPT_0x43
;    1436             // increase Sn_RX_RD as length of get_size
;    1437              printf("-7-");
	__POINTW1FN _0,283
	CALL SUBOPT_0x43
;    1438          	wiz_wr(Sn_RX_RD0(socket_no),(make8(get_offset,1)));
	LDD  R31,Y+12
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1064)
	SBCI R31,HIGH(-1064)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x37
;    1439 	         wiz_wr(Sn_RX_RD1(socket_no),(make8(get_offset,0)));
	LDD  R31,Y+12
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1065)
	SBCI R31,HIGH(-1065)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x37
;    1440 
;    1441 	          printf("-8-");
	__POINTW1FN _0,287
	CALL SUBOPT_0x43
;    1442       wiz_wr(Sn_CR(socket_no),Sn_CR_RECV);             //reset recieved data interrupt bit
	LDD  R31,Y+12
	CALL SUBOPT_0x42
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL SUBOPT_0x37
;    1443 	  return get_size;
	MOVW R30,R16
_0x21D:
	CALL __LOADLOCR6
	ADIW R28,14
	RET
;    1444 }
;    1445 
;    1446 /*****************************************************
;    1447 Storing Arrays
;    1448 *****************************************************/
;    1449 
;    1450 void store(unsigned char *src,unsigned char *dest,unsigned char size)
;    1451 {
_store:
;    1452 int k,l=0,b=0;
;    1453 for(k=0;k<size;k++)
	CALL SUBOPT_0x48
;	*src -> Y+9
;	*dest -> Y+7
;	size -> Y+6
;	k -> R16,R17
;	l -> R18,R19
;	b -> R20,R21
_0x135:
	LDD  R30,Y+6
	MOVW R26,R16
	CALL SUBOPT_0x44
	BRLT PC+3
	JMP _0x136
;    1454             {
;    1455                 if(src[k]=='*')
	CALL SUBOPT_0x49
	CPI  R26,LOW(0x2A)
	BRNE _0x137
;    1456                     src[k]=src[k-1];
	MOVW R30,R16
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x4A
	ST   X,R30
;    1457                 if(src[k]=='.' || src[k]=='A'/*Termination*/)
_0x137:
	CALL SUBOPT_0x49
	CPI  R26,LOW(0x2E)
	BREQ _0x139
	CALL SUBOPT_0x49
	CPI  R26,LOW(0x41)
	BREQ _0x139
	RJMP _0x138
_0x139:
;    1458                     {
;    1459                     if(!b)              //first number ,b points to first digit
	MOV  R0,R20
	OR   R0,R21
	BRNE _0x13B
;    1460                     switch (k-b)
	CALL SUBOPT_0x4B
;    1461                         {
;    1462                         case 1:  // 1 digit
	BRNE _0x13F
;    1463                             dest[l++]=src[k-1];
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4A
	RJMP _0x222
;    1464                             break;
;    1465 
;    1466                         case 2:  // 2 digits
_0x13F:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x140
;    1467                             dest[l++]=src[k-1]+src[k-2]*10;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	RJMP _0x223
;    1468                             break;
;    1469                         case 3:  // 3 digits
_0x140:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x13E
;    1470                             dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
_0x223:
	MUL  R30,R26
	MOVW R30,R0
	ADD  R30,R22
	__GETW2R 23,24
_0x222:
	ST   X,R30
;    1471                             break;
;    1472                         }
_0x13E:
;    1473                     else
	RJMP _0x142
_0x13B:
;    1474                     switch (k-b)     //the rest ,b points to '.'
	CALL SUBOPT_0x4F
;    1475                         {
;    1476                         case 2:  // 1 digit
	BRNE _0x146
;    1477                             dest[l++]=src[k-1];
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4A
	RJMP _0x224
;    1478                             break;
;    1479 
;    1480                         case 3:  // 2 digits
_0x146:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x147
;    1481                             dest[l++]=src[k-1]+src[k-2]*10;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	RJMP _0x225
;    1482                             break;
;    1483                         case 4:  // 3 digits
_0x147:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x145
;    1484                             dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
_0x225:
	MUL  R30,R26
	MOVW R30,R0
	ADD  R30,R22
	__GETW2R 23,24
_0x224:
	ST   X,R30
;    1485                             break;
;    1486                         }
_0x145:
_0x142:
;    1487                      }
;    1488                 }
_0x138:
	__ADDWRN 16,17,1
	RJMP _0x135
_0x136:
;    1489 }
	RJMP _0x21C
;    1490 
;    1491 void store_int(unsigned char *src,unsigned char *dest,unsigned char size)
;    1492 {
_store_int:
;    1493 int k,l=0,b=0;
;    1494 for(k=0;k<size;k++)
	CALL SUBOPT_0x48
;	*src -> Y+9
;	*dest -> Y+7
;	size -> Y+6
;	k -> R16,R17
;	l -> R18,R19
;	b -> R20,R21
_0x14A:
	LDD  R30,Y+6
	MOVW R26,R16
	CALL SUBOPT_0x44
	BRLT PC+3
	JMP _0x14B
;    1495             {
;    1496 
;    1497                 if(src[k]=='.' || src[k]==' '/*Termination*/)
	CALL SUBOPT_0x49
	CPI  R26,LOW(0x2E)
	BREQ _0x14D
	CALL SUBOPT_0x49
	CPI  R26,LOW(0x20)
	BREQ _0x14D
	RJMP _0x14C
_0x14D:
;    1498                     {
;    1499                     if(!b)              //first number ,b points to first digit
	MOV  R0,R20
	OR   R0,R21
	BRNE _0x14F
;    1500                     switch (k-b)
	CALL SUBOPT_0x4B
;    1501                         {
;    1502                         case 1:  // 1 digit
	BRNE _0x153
;    1503                             dest[l++]=src[k-1];
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4A
	RJMP _0x226
;    1504                             break;
;    1505 
;    1506                         case 2:  // 2 digits
_0x153:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x154
;    1507                             dest[l++]=src[k-1]+src[k-2]*10;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	RJMP _0x227
;    1508                             break;
;    1509                         case 3:  // 3 digits
_0x154:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x152
;    1510                             dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
_0x227:
	MUL  R30,R26
	MOVW R30,R0
	ADD  R30,R22
	__GETW2R 23,24
_0x226:
	ST   X,R30
;    1511                             break;
;    1512                         }
_0x152:
;    1513                     else
	RJMP _0x156
_0x14F:
;    1514                     switch (k-b)     //the rest ,b points to '.'
	CALL SUBOPT_0x4F
;    1515                         {
;    1516                         case 2:  // 1 digit
	BRNE _0x15A
;    1517                             dest[l++]=src[k-1];
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4A
	RJMP _0x228
;    1518                             break;
;    1519 
;    1520                         case 3:  // 2 digits
_0x15A:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x15B
;    1521                             dest[l++]=src[k-1]+src[k-2]*10;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	RJMP _0x229
;    1522                             break;
;    1523                         case 4:  // 3 digits
_0x15B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x159
;    1524                             dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
_0x229:
	MUL  R30,R26
	MOVW R30,R0
	ADD  R30,R22
	__GETW2R 23,24
_0x228:
	ST   X,R30
;    1525                             break;
;    1526                         }
_0x159:
_0x156:
;    1527                      }
;    1528                 }
_0x14C:
	__ADDWRN 16,17,1
	RJMP _0x14A
_0x14B:
;    1529 }
_0x21C:
	CALL __LOADLOCR6
	ADIW R28,11
	RET
;    1530 
;    1531 

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x15D
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x15F
	__CPWRN 16,17,2
	BRLO _0x160
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x15F:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x160:
	RJMP _0x161
_0x15D:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x161:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x162:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x164
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x168
	CPI  R18,37
	BRNE _0x169
	LDI  R17,LOW(1)
	RJMP _0x16A
_0x169:
	CALL SUBOPT_0x50
_0x16A:
	RJMP _0x167
_0x168:
	CPI  R30,LOW(0x1)
	BRNE _0x16B
	CPI  R18,37
	BRNE _0x16C
	CALL SUBOPT_0x50
	RJMP _0x22A
_0x16C:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x16D
	LDI  R16,LOW(1)
	RJMP _0x167
_0x16D:
	CPI  R18,43
	BRNE _0x16E
	LDI  R20,LOW(43)
	RJMP _0x167
_0x16E:
	CPI  R18,32
	BRNE _0x16F
	LDI  R20,LOW(32)
	RJMP _0x167
_0x16F:
	RJMP _0x170
_0x16B:
	CPI  R30,LOW(0x2)
	BRNE _0x171
_0x170:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x172
	ORI  R16,LOW(128)
	RJMP _0x167
_0x172:
	RJMP _0x173
_0x171:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x167
_0x173:
	CPI  R18,48
	BRLO _0x176
	CPI  R18,58
	BRLO _0x177
_0x176:
	RJMP _0x175
_0x177:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x167
_0x175:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x17B
	CALL SUBOPT_0x51
	LD   R30,X
	CALL SUBOPT_0x52
	RJMP _0x17C
_0x17B:
	CPI  R30,LOW(0x73)
	BRNE _0x17E
	CALL SUBOPT_0x51
	CALL SUBOPT_0x53
	CALL _strlen
	MOV  R17,R30
	RJMP _0x17F
_0x17E:
	CPI  R30,LOW(0x70)
	BRNE _0x181
	CALL SUBOPT_0x51
	CALL SUBOPT_0x53
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x17F:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x182
_0x181:
	CPI  R30,LOW(0x64)
	BREQ _0x185
	CPI  R30,LOW(0x69)
	BRNE _0x186
_0x185:
	ORI  R16,LOW(4)
	RJMP _0x187
_0x186:
	CPI  R30,LOW(0x75)
	BRNE _0x188
_0x187:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x189
_0x188:
	CPI  R30,LOW(0x58)
	BRNE _0x18B
	ORI  R16,LOW(8)
	RJMP _0x18C
_0x18B:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x1BD
_0x18C:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x189:
	SBRS R16,2
	RJMP _0x18E
	CALL SUBOPT_0x51
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x18F
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x18F:
	CPI  R20,0
	BREQ _0x190
	SUBI R17,-LOW(1)
	RJMP _0x191
_0x190:
	ANDI R16,LOW(251)
_0x191:
	RJMP _0x192
_0x18E:
	CALL SUBOPT_0x51
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x192:
_0x182:
	SBRC R16,0
	RJMP _0x193
_0x194:
	CP   R17,R21
	BRSH _0x196
	SBRS R16,7
	RJMP _0x197
	SBRS R16,2
	RJMP _0x198
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x199
_0x198:
	LDI  R18,LOW(48)
_0x199:
	RJMP _0x19A
_0x197:
	LDI  R18,LOW(32)
_0x19A:
	CALL SUBOPT_0x50
	SUBI R21,LOW(1)
	RJMP _0x194
_0x196:
_0x193:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x19B
_0x19C:
	CPI  R19,0
	BREQ _0x19E
	SBRS R16,3
	RJMP _0x19F
	CALL SUBOPT_0x45
	LPM  R30,Z
	RJMP _0x22B
_0x19F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x22B:
	ST   -Y,R30
	CALL SUBOPT_0x54
	CPI  R21,0
	BREQ _0x1A1
	SUBI R21,LOW(1)
_0x1A1:
	SUBI R19,LOW(1)
	RJMP _0x19C
_0x19E:
	RJMP _0x1A2
_0x19B:
_0x1A4:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x1A6:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x1A8
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x1A6
_0x1A8:
	CPI  R18,58
	BRLO _0x1A9
	SBRS R16,3
	RJMP _0x1AA
	SUBI R18,-LOW(7)
	RJMP _0x1AB
_0x1AA:
	SUBI R18,-LOW(39)
_0x1AB:
_0x1A9:
	SBRC R16,4
	RJMP _0x1AD
	CPI  R18,49
	BRSH _0x1AF
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x1AE
_0x1AF:
	RJMP _0x22C
_0x1AE:
	CP   R21,R19
	BRLO _0x1B3
	SBRS R16,0
	RJMP _0x1B4
_0x1B3:
	RJMP _0x1B2
_0x1B4:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x1B5
	LDI  R18,LOW(48)
_0x22C:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x1B6
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x54
	CPI  R21,0
	BREQ _0x1B7
	SUBI R21,LOW(1)
_0x1B7:
_0x1B6:
_0x1B5:
_0x1AD:
	CALL SUBOPT_0x50
	CPI  R21,0
	BREQ _0x1B8
	SUBI R21,LOW(1)
_0x1B8:
_0x1B2:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x1A5
	RJMP _0x1A4
_0x1A5:
_0x1A2:
	SBRS R16,0
	RJMP _0x1B9
_0x1BA:
	CPI  R21,0
	BREQ _0x1BC
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x52
	RJMP _0x1BA
_0x1BC:
_0x1B9:
_0x1BD:
_0x17C:
_0x22A:
	LDI  R17,LOW(0)
_0x167:
	RJMP _0x162
_0x164:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	CALL SUBOPT_0x55
	MOVW R26,R28
	ADIW R26,6
	CALL SUBOPT_0x56
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0x56
	CALL SUBOPT_0x57
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0x21B
_printf:
	PUSH R15
	CALL SUBOPT_0x55
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0x56
	CALL SUBOPT_0x57
_0x21B:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	CALL __lcd_delay_G3
	CALL __lcd_read_nibble_G3
    mov   r26,r30
	CALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R7,Y+1
	LDD  R6,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x20A
	__lcd_putchar1:
	INC  R6
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R6
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x20A:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R17
_0x20B:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x20D
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0x20B
_0x20D:
	LDD  R17,Y+0
	RJMP _0x21A
_lcd_putsf:
	ST   -Y,R17
_0x20E:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x210
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0x20E
_0x210:
	LDD  R17,Y+0
_0x21A:
	ADIW R28,3
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	CALL SUBOPT_0x58
	CALL SUBOPT_0x58
	CALL SUBOPT_0x58
	CALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(40)
	CALL SUBOPT_0x59
	LDI  R30,LOW(4)
	CALL SUBOPT_0x59
	LDI  R30,LOW(133)
	CALL SUBOPT_0x59
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x211
	LDI  R30,LOW(0)
	RJMP _0x219
_0x211:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x219:
	ADIW R28,1
	RET
_rtc_init:
	LD   R30,Y
	ANDI R30,LOW(0x3)
	ST   Y,R30
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x212
	LD   R30,Y
	ORI  R30,LOW(0xA0)
	ST   Y,R30
_0x212:
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRNE _0x213
	LD   R30,Y
	ORI  R30,4
	RJMP _0x22D
_0x213:
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BRNE _0x215
	LD   R30,Y
	ORI  R30,8
	RJMP _0x22D
_0x215:
	LDI  R30,LOW(0)
_0x22D:
	ST   Y,R30
	RCALL SUBOPT_0x5A
	LDI  R30,LOW(144)
	ST   -Y,R30
	LDD  R30,Y+1
	RCALL SUBOPT_0x5B
	RJMP _0x217
_rtc_get_time:
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x5C
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	LDI  R30,LOW(131)
	RCALL SUBOPT_0x5C
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(129)
	RCALL SUBOPT_0x5C
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	RJMP _0x218
_rtc_set_time:
	RCALL SUBOPT_0x5A
	LDI  R30,LOW(132)
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(130)
	RCALL SUBOPT_0x5E
	LDI  R30,LOW(128)
	RCALL SUBOPT_0x5F
	RJMP _0x217
_rtc_get_date:
	LDI  R30,LOW(135)
	RCALL SUBOPT_0x5C
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	LDI  R30,LOW(137)
	RCALL SUBOPT_0x5C
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(141)
	RCALL SUBOPT_0x5C
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
_0x218:
	ADIW R28,6
	RET
_rtc_set_date:
	RCALL SUBOPT_0x5A
	LDI  R30,LOW(134)
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(136)
	RCALL SUBOPT_0x5E
	LDI  R30,LOW(140)
	RCALL SUBOPT_0x5F
_0x217:
	ADIW R28,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:276 WORDS
SUBOPT_0x3:
	__PUTB1SX 116
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,65
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 120
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:152 WORDS
SUBOPT_0x4:
	__PUTB1SX 116
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,68
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 120
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:46 WORDS
SUBOPT_0x5:
	MOVW R26,R28
	SUBI R26,LOW(-(117))
	SBCI R27,HIGH(-(117))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x6:
	__GETW2SX 117
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	CALL _lcd_clear
	__POINTW1FN _0,71
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x8:
	__CLRW1SX 117
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x9:
	MOVW R26,R28
	ADIW R26,42
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:51 WORDS
SUBOPT_0xA:
	ADD  R26,R30
	ADC  R27,R31
	__GETB1SX 116
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	CALL _lcd_clear
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xC:
	__GETW1SX 117
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0xD:
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xE:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	__GETW1SX 117
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF:
	MOVW R26,R28
	SUBI R26,LOW(-(117))
	SBCI R27,HIGH(-(117))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0x11:
	__GETW1SX 117
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x12:
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R30
	__GETW1SX 118
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13:
	MOVW R26,R28
	ADIW R26,43
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	__GETW1SX 118
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x15:
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R30
	__GETW1SX 119
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	MOVW R26,R28
	ADIW R26,44
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	__GETW1SX 119
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x18:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x19:
	RCALL SUBOPT_0x11
	SBIW R30,1
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1A:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	CALL _lcd_clear
	__ADDWRN 20,21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1C:
	MOVW R30,R28
	ADIW R30,42
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x1D:
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 121
	ST   -Y,R30
	JMP  _store

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(1027)
	LDI  R31,HIGH(1027)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_rd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	CALL _lcd_clear
	__POINTW1FN _0,227
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x21:
	MOVW R30,R28
	SUBI R30,LOW(-(91))
	SBCI R31,HIGH(-(91))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(92))
	SBCI R31,HIGH(-(92))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(93))
	SBCI R31,HIGH(-(93))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_date
	MOVW R30,R28
	SUBI R30,LOW(-(94))
	SBCI R31,HIGH(-(94))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(96))
	SBCI R31,HIGH(-(96))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
	__GETB1SX 87
	__GETB2SX 94
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__GETB2SX 93
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	MOV  R26,R19
	LDI  R27,0
	LDI  R30,LOW(256)
	LDI  R31,HIGH(256)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	SUBI R30,LOW(-1062)
	SBCI R31,HIGH(-1062)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_rd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	SUBI R30,LOW(-1063)
	SBCI R31,HIGH(-1063)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_rd

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(_packet)
	LDI  R31,HIGH(_packet)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x27:
	MOVW R30,R20
	__ADDW1MN _packet,54
	MOVW R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x28:
	MOVW R26,R28
	ADIW R26,38
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP SUBOPT_0x26

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	MOVW R26,R28
	ADIW R26,29
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2B:
	STD  Z+0,R26
	MOVW R30,R20
	__ADDW1MN _packet,62
	LDI  R26,LOW(32)
	STD  Z+0,R26
	MOVW R30,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x2F:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x30:
	ADIW R26,1
	LD   R30,X
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x31:
	ADIW R26,2
	LD   R30,X
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x32:
	ADIW R26,3
	LD   R30,X
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LD   R30,X
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x35:
	ST   -Y,R17
	LDD  R31,Y+1
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1027)
	SBCI R31,HIGH(-1027)
	ST   -Y,R31
	ST   -Y,R30
	CALL _wiz_rd
	CPI  R30,LOW(0x13)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	LDD  R31,Y+1
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1025)
	SBCI R31,HIGH(-1025)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x37:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_wr

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x38:
	LDD  R31,Y+2
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1025)
	SBCI R31,HIGH(-1025)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x39:
	LDD  R31,Y+2
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1027)
	SBCI R31,HIGH(-1027)
	ST   -Y,R31
	ST   -Y,R30
	CALL _wiz_rd
	CPI  R30,LOW(0x13)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3A:
	CALL __SAVELOCR6
	LDD  R26,Y+7
	CPI  R26,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3B:
	MOV  R16,R30
	CLR  R17
	LDD  R31,Y+6
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x3C:
	MOV  R18,R30
	CLR  R19
	MOVW R30,R16
	ANDI R31,HIGH(0xFF)
	MOV  R31,R30
	LDI  R30,0
	MOVW R26,R30
	MOVW R30,R18
	ANDI R31,HIGH(0xFF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3D:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _wiz_rd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3E:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(2047)
	LDI  R31,HIGH(2047)
	AND  R30,R26
	AND  R31,R27
	MOVW R20,R30
	MOVW R30,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	MOVW R30,R16
	__ADDWRN 16,17,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	LD   R31,Y
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1027)
	SBCI R31,HIGH(-1027)
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LD   R31,Y
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1026)
	SBCI R31,HIGH(-1026)
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(0)
	SUBI R30,LOW(-1025)
	SBCI R31,HIGH(-1025)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x43:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x44:
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x45:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x46:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,54
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x48:
	CALL __SAVELOCR6
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x49:
	MOVW R30,R16
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x4A:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R16
	SBIW R30,1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4B:
	MOVW R30,R16
	SUB  R30,R20
	SBC  R31,R21
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x4C:
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:116 WORDS
SUBOPT_0x4D:
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1R 23,24
	MOVW R30,R16
	SBIW R30,1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X
	MOVW R30,R16
	SBIW R30,2
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDI  R30,LOW(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x4E:
	MUL  R30,R26
	MOVW R30,R0
	ADD  R22,R30
	MOVW R30,R16
	SBIW R30,3
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDI  R30,LOW(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4F:
	MOVW R30,R16
	SUB  R30,R20
	SBC  R31,R21
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x50:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x51:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x52:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x53:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x54:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x55:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x56:
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x57:
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	JMP  __print_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x58:
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5A:
	LDI  R30,LOW(142)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _ds1302_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x5B:
	ST   -Y,R30
	CALL _ds1302_write
	LDI  R30,LOW(142)
	ST   -Y,R30
	LDI  R30,LOW(128)
	ST   -Y,R30
	JMP  _ds1302_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x5C:
	ST   -Y,R30
	CALL _ds1302_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5D:
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	JMP  _ds1302_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5E:
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	JMP  _ds1302_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5F:
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _bin2bcd
	RJMP SUBOPT_0x5B

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	brlo __isspace0
	cpi  r31,14
	brlo __isspace1
__isspace0:
	clr  r30
__isspace1:
	ret

_isxdigit:
	ldi  r30,1
	ld   r31,y+
	subi r31,0x30
	brcs __isxdigit0
	cpi  r31,10
	brcs __isxdigit1
	andi r31,0x5f
	subi r31,7
	cpi  r31,10
	brcs __isxdigit0
	cpi  r31,16
	brcs __isxdigit1
__isxdigit0:
	clr  r30
__isxdigit1:
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x733
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_bcd2bin:
	ld   r30,y
	swap r30
	andi r30,0xf
	mov  r26,r30
	lsl  r26
	lsl  r26
	add  r30,r26
	lsl  r30
	ld   r26,y+
	andi r26,0xf
	add  r30,r26
	ret

_bin2bcd:
	ld   r26,y+
	clr  r30
__bin2bcd0:
	subi r26,10
	brmi __bin2bcd1
	subi r30,-16
	rjmp __bin2bcd0
__bin2bcd1:
	subi r26,-10
	add  r30,r26
	ret

_ds1302_read:
	ld   r30,y+
	sbr  r30,1
	rcall __ds1302_write0
	cbi  __ds1302_port,__ds1302_io
	cbi  __ds1302_port-1,__ds1302_io
	ldi  r26,8
__ds1302_read0:
	clc
	sbic __ds1302_port-2,__ds1302_io
	sec
	ror  r30
	sbi  __ds1302_port,__ds1302_sclk
	__DELAY_USB 0x5
	cbi  __ds1302_port,__ds1302_sclk
	__DELAY_USB 0x5
	dec  r26
	brne __ds1302_read0
__ds1302_rst0:
	cbi  __ds1302_port,__ds1302_rst
	__DELAY_USB 0xC
	ret

_ds1302_write:
	ldd  r30,y+1
	cbr  r30,1
	rcall __ds1302_write0
	ld   r30,y
	rcall __ds1302_write1
	adiw r28,2
	rjmp __ds1302_rst0

__ds1302_write0:
	sbi  __ds1302_port-1,__ds1302_sclk
	sbi  __ds1302_port-1,__ds1302_io
	sbi  __ds1302_port-1,__ds1302_rst
	sbi  __ds1302_port,__ds1302_rst
	__DELAY_USB 0xC
__ds1302_write1:
	ldi  r26,8
__ds1302_write2:
	ror  r30
	cbi  __ds1302_port,__ds1302_io
	brcc __ds1302_write3
	sbi  __ds1302_port,__ds1302_io
__ds1302_write3:
	nop
	nop
	nop
	nop
	sbi  __ds1302_port,__ds1302_sclk
	__DELAY_USB 0x5
	cbi  __ds1302_port,__ds1302_sclk
	__DELAY_USB 0x5
	dec  r26
	brne __ds1302_write2
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
